{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING icomun.dao.GenericServiceDelegate.
USING icomun.dao.SessionManager.
USING nsra.utiles.excepciones.Exception.
USING sports.dao.Empleado.

/*
Implements Timesheet entity, dependant on Employee entity.
*/
CLASS sports.dao.Horario INHERITS GenericServiceDelegate:
  /*
  Same temp-table definition as in Employee, but only by reference.
  */

  /* properties to access attributes (tt fields) */
  
  CONSTRUCTOR PUBLIC Horario(INPUT ipobOwner AS CLASS Empleado, INPUT TABLE <tt name> BIND, INPUT ipobSessionManager AS CLASS SessionManager):
    SUPER(ipobOwner, <tt handle>, ipobSessionManager).
    /* If the object temp-table doesn't have uid field, remember to set cinSequencedField to ? */
	END CONSTRUCTOR.

  CONSTRUCTOR PUBLIC Horario(INPUT ipobOwner AS CLASS Empleado, INPUT TABLE <tt name> BIND, INPUT ipobSessionManager AS CLASS SessionManager, INPUT iphnRelation AS HANDLE):
  END CONSTRUCTOR.

  /*
  check everything!
  */
	METHOD PUBLIC OVERRIDE VOID AssignValues ( iphbBuffer AS HANDLE, ipchFieldMap AS CHARACTER ):
	 /* check required fields (look at inherited method verifyFields())*/

   /* check for at least one entry and one exit, and one of the hours quantities */

    /* Guarantee that is the right employee */
    <tt field> = CAST(cobOwner,Empleado):<numbre property>. 
	END METHOD.
END CLASS.