{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING icomun.dao.*.
USING nsxml.dao.*.
USING nsxml.utiles.*.
USING sports.dao.*.
USING nsra.utiles.ExpManagerSQL.
USING nsra.utiles.excepciones.Exception.

DEFINE INPUT PARAMETER lobSM AS CLASS SessionManager.

/* tts you will need */

/* purchase order grid */
PROCEDURE gridOrdenCompra:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchSearch AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchKeyField AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchRows AS INTEGER NO-UNDO.
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchDirection AS CHARACTER NO-UNDO.

  DEFINE OUTPUT  PARAMETER ophnSalida AS HANDLE NO-UNDO.

  DEFINE VARIABLE iobCallee AS CLASS OrdenCompra NO-UNDO.
  DEFINE VARIABLE iobGeneric AS CLASS XULService NO-UNDO.

  /* get instances */
  
  ophnSalida = <result table handle>.
  /* don't forget about datetime fields format */
  
  /* don't allow a "full fill", if everything is requested, return nothing */
  
  iobGeneric:FillTable(iobCallee,ipchSQL,ipchSQL, ipchSearch, ipchColumns, ipchKeyField, ipchRows, ipchReference, ipchDirection, ophnSalida, iobCallee, '').

  /* if field 'total' has been requested, calculate the total amount for each "document" */
    
  FINALLY:
    /* make them free!! or at least free the objects. */
  END FINALLY.
END PROCEDURE.

/* purchase order CRUD */
PROCEDURE postOrdenCompra:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER iphnDels AS HANDLE NO-UNDO.
  DEFINE INPUT  PARAMETER iphnAdds AS HANDLE NO-UNDO.
  DEFINE INPUT  PARAMETER iphnUpds AS HANDLE NO-UNDO.

  DEFINE OUTPUT  PARAMETER ophnResultado AS LOGICAL NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnDels AS HANDLE NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnAdds AS HANDLE NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnUpds AS HANDLE NO-UNDO.

  ophnResultado = <>:SaveChanges(ipchSQL,ipchReference,ipchColumns,iphnDels,iphnAdds,iphnUpds,<>,<>,<>,'').
  ophnDels = <>:htDeletes.
  ophnAdds = <>:htAdds.
  ophnUpds = <>:htUpdates.

  FINALLY:
  END FINALLY.
END PROCEDURE.


/* purchase order lines grid */
PROCEDURE griditemcompra:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchSearch AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchKeyField AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipinRows AS INTEGER NO-UNDO.
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchDirection AS CHARACTER NO-UNDO.

  DEFINE OUTPUT  PARAMETER ophnSalida AS HANDLE NO-UNDO.

  /* filter criteria is for items (lines) but to get them, first you need
  the purchase order they belong to */
  ASSIGN
    <> = CAST(lobSM:cobExpManager,ExpManagerSQL):reducirExpresionLogica(ipchSQL,'<>')
    <> = (IF ichFilter EQ '' THEN <> ELSE REPLACE(ichFilter,'<>','<>'))
  {&END}

  <>:FillTable(<>,<>,ipchSQL, ipchSearch, ipchColumns, ipchKeyField, ipinRows, ipchReference, ipchDirection, ophnSalida, <>, '<>,ordencompra').

  /* at this point, you are missing items descriptions, add them to result */
  FOR EACH <> BY <>:
  END.

  FINALLY:
    /* do I have to say it again? */
  END FINALLY.
END PROCEDURE.

/* purchase order lines CRUD */
PROCEDURE postitemcompra:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER iphnDels AS HANDLE NO-UNDO.
  DEFINE INPUT  PARAMETER iphnAdds AS HANDLE NO-UNDO.
  DEFINE INPUT  PARAMETER iphnUpds AS HANDLE NO-UNDO.

  DEFINE OUTPUT  PARAMETER ophnResultado AS LOGICAL NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnDels AS HANDLE NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnAdds AS HANDLE NO-UNDO.
  DEFINE OUTPUT  PARAMETER ophnUpds AS HANDLE NO-UNDO.

  /* no need to alter fill criteria in this case... */  
  ophnResultado = <>:SaveChanges(ipchSQL, ipchReference, ipchColumns, iphnDels, iphnAdds, iphnUpds, <>, <>, <>, '<>,ordencompra').
  ophnDels = <>:htDeletes.
  ophnAdds = <>:htAdds.
  ophnUpds = <>:htUpdates.

  FINALLY:
    /* as always.. */
  END FINALLY.
END PROCEDURE.
