{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING icomun.dao.GenericServiceDAO.
USING icomun.dao.SessionManager.
USING nsra.utiles.excepciones.Exception.

CLASS sports.dao.Situacion INHERITS GenericServiceDAO:
  {sports/tablas/Situacion.i &SCOPE=PROTECTED &ENV=c}

  DEFINE PROTECTED DATASET cpdSituacion FOR cttSituacion.

  DEFINE PUBLIC PROPERTY cchSituacion AS CHARACTER NO-UNDO
    GET():
      RETURN chGetFieldValue('id').
    END GET.
    SET(INPUT ipchSituacion AS CHARACTER):
      setFieldValue('id',ipchSituacion).
    END SET.

  DEFINE PUBLIC PROPERTY cchNombre AS CHARACTER NO-UNDO
    GET():
      RETURN chGetFieldValue('Nombre').
    END GET.
    SET(INPUT ipchNombre AS CHARACTER):
      SetFieldValue('Nombre', ipchNombre).
    END SET.
 
  /**
   *
   */
  CONSTRUCTOR PUBLIC Situacion():
	  SUPER(BUFFER cttSituacion:HANDLE).
	END CONSTRUCTOR.

  CONSTRUCTOR PUBLIC Situacion(INPUT ipobSessionManager AS CLASS SessionManager):
	  SUPER(BUFFER cttSituacion:HANDLE, ipobSessionManager).
	END CONSTRUCTOR.

  CONSTRUCTOR PUBLIC Situacion(INPUT ipchFiltro AS CHARACTER, INPUT ipobSessionManager AS CLASS SessionManager):
	  SUPER(BUFFER cttSituacion:HANDLE, ipobSessionManager).
    FillData(ipchFiltro).
	END CONSTRUCTOR.

	METHOD PUBLIC OVERRIDE VOID AssignValues ( iphbBuffer AS HANDLE, ipchFieldMap AS CHARACTER ):
    UNDO, THROW NEW Exception("No se pueden modificar las situaciones.").
	END METHOD.
	METHOD PUBLIC OVERRIDE ROWID CreateIt():
    UNDO, THROW NEW Exception("No se pueden crear situaciones.").
	END METHOD.
	METHOD PUBLIC OVERRIDE ROWID DeleteIt():
    UNDO, THROW NEW Exception("No se pueden eliminar situaciones.").
	END METHOD.

END CLASS.
