{nsra/utiles/runlevel.i}
{sports/utiles/dbase.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING nsra.dso.ReferencedDataSource.

CLASS sports.dso.Cliente INHERITS nsra.dso.ReferencedDataSource:
  DEFINE PROTECTED BUFFER cbfCustomer FOR {&SPORTS-DB}.Customer.

	METHOD PROTECTED OVERRIDE VOID DefineDataSource():
    AddBuffer(BUFFER cbfCustomer:HANDLE, "CustNum").
    AddMapField("cbfCustomer", "CustNum",  "Codigo", TRUE,TRUE). /* se autoincrementa*/
    AddMapField("cbfCustomer", "Country", "Pais", TRUE).
    AddMapField("cbfCustomer", "Name", "Nombre", TRUE).
    AddMapField("cbfCustomer", "Address", "Direccion",  TRUE).
    AddMapField("cbfCustomer", "Address2","DireccionAlternativa", TRUE).
    AddMapField("cbfCustomer", "City","Ciudad",TRUE).
    AddMapField("cbfCustomer", "State","Estado",TRUE).
    AddMapField("cbfCustomer", "PostalCode","CodigoPostal",TRUE).
    AddMapField("cbfCustomer", "Phone","Telefono",TRUE).
    AddMapField("cbfCustomer", "Contact","Contacto",TRUE).
    AddMapField("cbfCustomer", "SalesRep","RepresentanteDeVentas",TRUE).
    AddMapField("cbfCustomer", "CreditLimit","LimiteCredito").
    AddMapField("cbfCustomer", "Balance", "Balance").
    AddMapField("cbfCustomer", "Terms", "Condiciones").
    AddMapField("cbfCustomer", "Discount", "Descuento", TRUE).
    AddMapField("cbfCustomer", "Comments", "Observaciones").
    AddMapField("cbfCustomer", "Fax", "Fax", TRUE).
    AddMapField("cbfCustomer", "EmailAddress", "CorreoE", TRUE).
	END METHOD.

  METHOD PROTECTED OVERRIDE VOID SetUpRelations():
    AddRelation(ACTION_CASCADE,OPERATION_UPDATE,'sports.dso.RepresentanteVentas','Identificador','RepresentanteDeVentas').
    AddRelation(ACTION_CHANGE,OPERATION_DELETE,'sports.dso.RepresentanteVentas','Identificador','RepresentanteDeVentas','?').
  END METHOD.
END CLASS.
