{nsra/utiles/runlevel.i}
{sports/utiles/dbase.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING nsra.dso.ReferencedDataSource.

/* <%TRADUCCION%>esta clase se encarga de realizar el llenado de la Temp-Table con el mismo nombre, como as tambin de la grabacin
de los cambios en la base de datos</%TRADUCCION%> */
CLASS sports.dso.Empleado INHERITS nsra.dso.ReferencedDataSource:
  DEFINE PROTECTED BUFFER cbfEmployee FOR {&SPORTS-DB}.Employee.

	METHOD PROTECTED OVERRIDE VOID DefineDataSource():
	  /* <%TRADUCCION%>esta es la forma ms simple de definicin, en donde lo nico que se requiere es un mapeo directo de los
	  campos de la Temp-Table respecto de los de la tabla correspondiente en la base de datos</%TRADUCCION%> */
    AddBuffer(BUFFER cbfEmployee:HANDLE, "EmpNum").
    AddMapField("cbfEmployee", "EmpNum",  "Codigo", TRUE,TRUE). /* <%TRADUCCION%>si no se especifica, se autoincrementa (5 parmetro)</%TRADUCCION%>*/
    AddMapField("cbfEmployee", "LastName", "Apellido", TRUE).
    AddMapField("cbfEmployee", "FirstName", "Nombre", TRUE).
    AddMapField("cbfEmployee", "Address", "Direccion",  TRUE).
    AddMapField("cbfEmployee", "Address2","DireccionAlternativa", TRUE).
    AddMapField("cbfEmployee", "City","Ciudad",TRUE).
    AddMapField("cbfEmployee", "State","Estado",TRUE).
    AddMapField("cbfEmployee", "PostalCode","CodigoPostal",TRUE).
    AddMapField("cbfEmployee", "DeptCode","Departamento",TRUE).
    AddMapField("cbfEmployee", "Position","Posicion",TRUE).
    AddMapField("cbfEmployee", "HomePhone","TelefonoPersonal",TRUE).
    AddMapField("cbfEmployee", "WorkPhone","TelefonoLaboral",TRUE).
    AddMapField("cbfEmployee", "VacationDaysLeft", "VacacionesRemanentes", TRUE).
    AddMapField("cbfEmployee", "SickDaysLeft", "DiasPorEnfermedadRemanentes", TRUE).
    AddMapField("cbfEmployee", "StartDate", "Inicio", TRUE).
    AddMapField("cbfEmployee", "BirthDate", "Nacimiento", TRUE).
	END METHOD.

  METHOD PROTECTED OVERRIDE VOID SetUpRelations():
    /* <%TRADUCCION%>restricciones de integridad referencial</%TRADUCCION%> */
    AddRelation(ACTION_CASCADE,OPERATION_UPDATE,'sports.dso.Departamento','Identificador','Departamento').
    AddRelation(ACTION_CHANGE,OPERATION_DELETE,'sports.dso.Departamento','Identificador','Departamento','').
  END METHOD.
END CLASS.
