{nsra/utiles/runlevel.i}
{sports/utiles/dbase.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING nsra.dso.ReferencedDataSource.

CLASS  sports.dso.Estante  INHERITS  nsra.dso.ReferencedDataSource:
  DEFINE PROTECTED BUFFER cbfBin  FOR  {&SPORTS-DB}.Bin.

	METHOD PROTECTED OVERRIDE VOID  DefineDataSource() :
      AddBuffer(BUFFER cbfBin:HANDLE, "BinNum").
    
      AddMapField( "cbfBin", "BinNum",       "CodigoEstante",     TRUE,  TRUE ).  /* se autoincrementa */
      AddMapField( "cbfBin", "BinName",      "Nombre",            TRUE ).
      AddMapField( "cbfBin", "Itemnum",      "CodigoArticulo",    TRUE ).
      AddMapField( "cbfBin", "Qty",          "Cantidad",          TRUE ).
      AddMapField( "cbfBin", "WarehouseNum", "CodigoAlmacen",     TRUE ).
        
	END METHOD.

  METHOD PROTECTED OVERRIDE VOID  SetUpRelations():
      AddRelation(ACTION_CASCADE, OPERATION_UPDATE, 'sports.dso.Almacen',  'Numero', 'CodigoAlmacen').
      AddRelation(ACTION_CASCADE, OPERATION_DELETE, 'sports.dso.Almacen',  'Numero', 'CodigoAlmacen').
      AddRelation(ACTION_CASCADE, OPERATION_UPDATE, 'sports.dso.Articulo', 'Codigo', 'CodigoArticulo').
      AddRelation(ACTION_CHANGE,  OPERATION_DELETE, 'sports.dso.Articulo', 'Codigo', 'CodigoArticulo', '').   
  END METHOD.
  
END CLASS.