{nsra/utiles/runlevel.i}
{sports/utiles/dbase.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING nsra.dso.ReferencedDataSource.

CLASS sports.dso.LineaDocumento INHERITS nsra.dso.ReferencedDataSource:
  DEFINE PROTECTED BUFFER cbfOrderLine FOR {&SPORTS-DB}.OrderLine.
  DEFINE PROTECTED BUFFER cbfPOrderLine FOR {&SPORTS-DB}.POLine.

  DEFINE PUBLIC PROPERTY cchDataSource AS CHARACTER INITIAL 'Order' NO-UNDO
    GET.
    SET(INPUT ipchDataSource AS CHARACTER):
      IF ipchDataSource EQ cchDataSource OR LOOKUP(ipchDataSource,'Order,PurchaseOrder') EQ 0 THEN
        RETURN.
      cchDataSource = ipchDataSource.
      ResetDefinition().
    END SET.

	METHOD PROTECTED OVERRIDE VOID DefineDataSource():
    IF cchDataSource EQ 'PurchaseOrder' THEN DO:
      AddBuffer(BUFFER cbfPOrderLine:HANDLE, "PONum,linenum").
      AddMapField("cbfPOrderLine", "PONum",  "Documento", TRUE). 
      AddMapField("cbfPOrderLine", "Linenum", "Numero", TRUE,TRUE). /* autoincrementar */
      AddMapField("cbfPOrderLine", "ItemNum", "Articulo", TRUE).
      AddMapField("cbfPOrderLine", "Price", "Precio").
      AddMapField("cbfPOrderLine", "Qty", "Cantidad").
      AddMapField("cbfPOrderLine", "Discount", "Descuento").
      AddMapField("cbfPOrderLine", "ExtendedPrice", "PrecioExtendido").
      AddMapField("cbfPOrderLine", "POLineStatus", "Estado", TRUE).
    END.
    ELSE DO:
      AddBuffer(BUFFER cbfOrderLine:HANDLE, "Ordernum,Linenum").
      AddMapField("cbfOrderLine", "OrderNum",  "Documento", TRUE).
      AddMapField("cbfOrderLine", "Linenum", "Numero", TRUE,TRUE). /* autoincrementar */
      AddMapField("cbfOrderLine", "ItemNum", "Articulo", TRUE).
      AddMapField("cbfOrderLine", "Price", "Precio").
      AddMapField("cbfOrderLine", "Qty", "Cantidad").
      AddMapField("cbfOrderLine", "Discount", "Descuento").
      AddMapField("cbfOrderLine", "ExtendedPrice", "PrecioExtendido").
      AddMapField("cbfOrderLine", "OrderLineStatus", "Estado", TRUE).
    END.
	END METHOD.
END CLASS.
