{nsra/utiles/runlevel.i}
{sports/utiles/dbase.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING nsra.dso.ReferencedDataSource.

CLASS  sports.dso.MovimientoInventario  INHERITS  nsra.dso.ReferencedDataSource :
  DEFINE PROTECTED BUFFER cbfInventoryTrans  FOR  {&SPORTS-DB}.InventoryTrans.

   METHOD PROTECTED OVERRIDE VOID  DefineDataSource() :
     AddBuffer(BUFFER cbfInventoryTrans:HANDLE, "InvTransNum").
        
     AddMapField("cbfInventoryTrans", "InvTransNum",      "CodigoMovimiento",  TRUE, TRUE).   /* <%TRADUCCION%> se autoincrementa </%TRADUCCION%> */
     AddMapField("cbfInventoryTrans", "WarehouseNum",     "CodigoAlmacen").
     AddMapField("cbfInventoryTrans", "BinNum",           "CodigoEstante").
     AddMapField("cbfInventoryTrans", "Qty",              "Cantidad").
     AddMapField("cbfInventoryTrans", "Itemnum",          "CodigoArticulo").
     AddMapField("cbfInventoryTrans", "TransDate",        "FechaMovimiento",   TRUE).
     AddMapField("cbfInventoryTrans", "HorarioMovimiento","Transtime",         TRUE).
     AddMapField("cbfInventoryTrans", "InvType",          "Tipo",              TRUE).
     AddMapField("cbfInventoryTrans", "PONum",            "CodigoOrdenCompra", TRUE).
     AddMapField("cbfInventoryTrans", "Ordernum",         "CodigoOrdenVenta",  TRUE).        
   END METHOD.
   
  METHOD PROTECTED OVERRIDE VOID  SetUpRelations(): /* <%TRADUCCION%> Para proteger la integridad referencial. </%TRADUCCION%> */
     AddRelation(ACTION_CASCADE, OPERATION_UPDATE, 'sports.dso.Almacen',  'Numero',        'CodigoAlmacen').
     AddRelation(ACTION_CHANGE,  OPERATION_DELETE, 'sports.dso.Almacen',  'Numero',        'CodigoAlmacen',       '').
     AddRelation(ACTION_CASCADE, OPERATION_UPDATE, 'sports.dso.Articulo', 'Codigo',        'CodigoArticulo').
     AddRelation(ACTION_CHANGE,  OPERATION_DELETE, 'sports.dso.Articulo', 'Codigo',        'CodigoArticulo',      ''). 
     AddRelation(ACTION_CASCADE, OPERATION_UPDATE, 'sports.dso.Estante',  'CodigoEstante', 'CodigoEstante').
     AddRelation(ACTION_CHANGE,  OPERATION_DELETE, 'sports.dso.Estante',  'CodigoEstante', 'CodigoEstante',       '').
     AddRelation(ACTION_CASCADE, OPERATION_UPDATE, 'sports.dso.Estante',  'CodigoEstante', 'CodigoOrdenCompra').
     AddRelation(ACTION_CHANGE,  OPERATION_DELETE, 'sports.dso.Estante',  'CodigoEstante', 'CodigoOrdenCompra',   '').
     AddRelation(ACTION_CASCADE, OPERATION_UPDATE, 'sports.dso.Estante',  'Numero',        'CodigoOrdenVenta').
     AddRelation(ACTION_CHANGE,  OPERATION_DELETE, 'sports.dso.Estante',  'Numero',        'CodigoOrdenVenta',    '').   
  END METHOD.
   
END CLASS.