{nsra/utiles/runlevel.i}
{sports/utiles/dbase.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING nsra.dso.ReferencedDataSource.

CLASS sports.dso.OrdenCompra INHERITS nsra.dso.ReferencedDataSource:
  DEFINE PROTECTED BUFFER cbfOrder FOR {&SPORTS-DB}.PurchaseOrder.

	METHOD PROTECTED OVERRIDE VOID DefineDataSource():
    AddBuffer(BUFFER cbfOrder:HANDLE, "PONum").
    AddMapField("cbfOrder", "PONum",  "Numero", TRUE).
    /* AddMapField("cbfOrder", "ReceiveDate", "Recepcion", TRUE). no pueden mapearse por ser de distinto tipo */
    AddFillEvent(AFTER-ROW-FILL, 'PostRowFill').
	END METHOD.

  METHOD PUBLIC INTEGER PostRowFill(INPUT DATASET-HANDLE iphdDataSet):
    DEFINE VARIABLE mhbBuffer AS HANDLE      NO-UNDO.

    mhbBuffer = chsDataSourceBase:GET-DATASET-BUFFER.
    mhbBuffer:BUFFER-FIELD('Recepcion'):BUFFER-VALUE = cbfOrder.ReceiveDate.
  END METHOD.

  METHOD PUBLIC OVERRIDE VOID PostSaveRow(INPUT iphbBuffer AS HANDLE, INPUT-OUTPUT iplgEndStatus AS LOGICAL, INPUT-OUTPUT iplgStopEvent AS LOGICAL):
    SUPER:PostSaveRow(iphbBuffer, iplgEndStatus, iplgStopEvent).

    DEFINE VARIABLE mhbAfter AS HANDLE NO-UNDO.
    DEFINE BUFFER mbfOrder FOR {&SPORTS-DB}.PurchaseOrder.

    IF NOT iplgStopEvent AND (iphbBuffer:ROW-STATE EQ ROW-MODIFIED OR iphbBuffer:ROW-STATE EQ ROW-CREATED) THEN DO ON ERROR UNDO:
      mhbAfter = iphbBuffer:AFTER-BUFFER.
      mhbAfter:FIND-BY-ROWID(iphbBuffer:AFTER-ROWID).
        
      FIND mbfOrder WHERE mbfOrder.PONum EQ mhbAfter:BUFFER-FIELD('Numero'):BUFFER-VALUE NO-ERROR.
      IF AVAILABLE mbfOrder THEN
        mbfOrder.ReceiveDate = mhbAfter:BUFFER-FIELD('Recepcion'):BUFFER-VALUE.
    END.
  END METHOD.
END CLASS.
