/* <%TRADUCCION%>{&SCOPE} se utiliza para definir la visibilidad de la definicin cuando la inclusin se hace en una clase
   {&ENV} permite agregar el caracter inicial que posibilita incluir varias veces la definicin con diferentes nombres
   {&REF-ONLY} se especifica como TRUE cuando la inclusin la realiza un BaseDAODelegate
   {&EXTRA-FIELDS} permite agregar campos a la definicin al momento de la inclusin. Se lo utiliza en los archivos de servicios</%TRADUCCION%>
    
   <%TRADUCCION%>Esta tabla es naturalmente "hija" de Empleado, pero para demostrar la funcionalidad del modelo se ha utilizado como
   tabla principal de una entidad principal independiente.</%TRADUCCION%> */
DEFINE {&SCOPE} TEMP-TABLE {&ENV}ttBeneficio NO-UNDO  &IF {&REF-ONLY} &THEN REFERENCE-ONLY &ENDIF
  BEFORE-TABLE {&ENV}ttbfBeneficio
  FIELD Empleado AS INTEGER
  FIELD SeguroSocial AS CHARACTER
  FIELD SeguroDeVida AS INTEGER
  FIELD Pension401K AS INTEGER
  FIELD CompraAcciones AS INTEGER
  FIELD GastosMedicos AS INTEGER
  FIELD Dependientes AS INTEGER
  {&EXTRA-FIELDS}
  INDEX pkBeneficio IS PRIMARY IS UNIQUE Empleado
  INDEX ixSeguro IS UNIQUE SeguroSocial.
