/* <%TRADUCCION%>{&SCOPE} se utiliza para definir la visibilidad de la definicin cuando la inclusin se hace en una clase
   {&ENV} permite agregar el caracter inicial que posibilita incluir varias veces la definicin con diferentes nombres
   {&REF-ONLY} se especifica como TRUE cuando la inclusin la realiza un BaseDAODelegate
   {&EXTRA-FIELDS} permite agregar campos a la definicin al momento de la inclusin. Se lo utiliza en los archivos de servicios</%TRADUCCION%> */
DEFINE {&SCOPE} TEMP-TABLE {&ENV}ttCliente NO-UNDO  &IF {&REF-ONLY} &THEN REFERENCE-ONLY &ENDIF
  BEFORE-TABLE {&ENV}ttbfCliente
  FIELD Codigo AS INTEGER INITIAL ?
  FIELD Pais AS CHARACTER
  FIELD Nombre AS CHARACTER
  FIELD Direccion AS CHARACTER
  FIELD DireccionAlternativa AS CHARACTER
  FIELD Ciudad AS CHARACTER
  FIELD Estado AS CHARACTER
  FIELD CodigoPostal AS CHARACTER
  FIELD Telefono AS CHARACTER
  FIELD Contacto AS CHARACTER
  FIELD RepresentanteDeVentas AS CHARACTER
  FIELD LimiteCredito AS DECIMAL
  FIELD Balance AS DECIMAL
  FIELD Condiciones AS CHARACTER
  FIELD Descuento AS INTEGER
  FIELD Observaciones AS CHARACTER
  FIELD Fax AS CHARACTER
  FIELD CorreoE AS CHARACTER
  {&EXTRA-FIELDS}
  INDEX pkCliente IS PRIMARY IS UNIQUE Codigo
  INDEX ixNombre Nombre Pais Estado Ciudad.
