/* <%TRADUCCION%>{&SCOPE} se utiliza para definir la visibilidad de la definicin cuando la inclusin se hace en una clase
   {&ENV} permite agregar el caracter inicial que posibilita incluir varias veces la definicin con diferentes nombres
   {&REF-ONLY} se especifica como TRUE cuando la inclusin la realiza un BaseDAODelegate
   {&EXTRA-FIELDS} permite agregar campos a la definicin al momento de la inclusin. Se lo utiliza en los archivos de servicios</%TRADUCCION%> */
DEFINE {&SCOPE} TEMP-TABLE {&ENV}ttEmpleado NO-UNDO  &IF {&REF-ONLY} &THEN REFERENCE-ONLY &ENDIF
  BEFORE-TABLE {&ENV}ttbfEmpleado
  FIELD Codigo AS INTEGER INITIAL ?
  FIELD Departamento AS CHARACTER 
  FIELD Apellido AS CHARACTER
  FIELD Nombre AS CHARACTER
  FIELD Direccion AS CHARACTER
  FIELD DireccionAlternativa AS CHARACTER
  FIELD Ciudad AS CHARACTER
  FIELD Estado AS CHARACTER
  FIELD CodigoPostal AS CHARACTER
  FIELD TelefonoPersonal AS CHARACTER
  FIELD TelefonoLaboral AS CHARACTER
  FIELD Posicion AS CHARACTER
  FIELD VacacionesRemanentes AS INTEGER
  FIELD DiasPorEnfermedadRemanentes AS INTEGER
  FIELD Inicio AS DATE
  FIELD Nacimiento AS DATE
  {&EXTRA-FIELDS}
  INDEX pkEmpleado IS PRIMARY IS UNIQUE Codigo
  INDEX ixNombre Apellido Nombre.
