/* <%TRADUCCION%>{&SCOPE} se utiliza para definir la visibilidad de la definicin cuando la inclusin se hace en una clase
   {&ENV} permite agregar el caracter inicial que posibilita incluir varias veces la definicin con diferentes nombres
   {&REF-ONLY} se especifica como TRUE cuando la inclusin la realiza un BaseDAODelegate
   {&EXTRA-FIELDS} permite agregar campos a la definicin al momento de la inclusin. Se lo utiliza en los archivos de servicios</%TRADUCCION%>
   
   <%TRADUCCION%>Esta tabla complementa a Documento para formar la factura</%TRADUCCION%> */
DEFINE {&SCOPE} TEMP-TABLE {&ENV}ttFactura NO-UNDO  &IF {&REF-ONLY} &THEN REFERENCE-ONLY &ENDIF
  BEFORE-TABLE {&ENV}ttbfFactura
  FIELD Numero AS INTEGER
  FIELD Monto AS DECIMAL
  FIELD Pagado AS DECIMAL
  FIELD Ajuste AS DECIMAL
  FIELD OrdenVenta AS INTEGER
  FIELD CostoDeEnvio AS DECIMAL
  {&EXTRA-FIELDS}
  INDEX pkFactura IS PRIMARY IS UNIQUE Numero
  INDEX ixOrden OrdenVenta
  INDEX ixPago Monto Pagado Ajuste.
