/* <%TRADUCCION%>{&SCOPE} se utiliza para definir la visibilidad de la definicin cuando la inclusin se hace en una clase
   {&ENV} permite agregar el caracter inicial que posibilita incluir varias veces la definicin con diferentes nombres
   {&REF-ONLY} se especifica como TRUE cuando la inclusin la realiza un BaseDAODelegate
   {&EXTRA-FIELDS} permite agregar campos a la definicin al momento de la inclusin. Se lo utiliza en los archivos de servicios</%TRADUCCION%>
   
   <%TRADUCCION%>Esta tabla es "hija" de Empleado y contendr los datos de cada uno de los familiares de cada empleado.</%TRADUCCION%> */
DEFINE {&SCOPE} TEMP-TABLE {&ENV}ttFamilia NO-UNDO  &IF {&REF-ONLY} &THEN REFERENCE-ONLY &ENDIF
  BEFORE-TABLE {&ENV}ttbfFamilia
  
  FIELD CodEmpleado AS INTEGER 
  FIELD Nombre AS CHARACTER 
  FIELD Parentesco AS CHARACTER
  FIELD FechaNacimiento AS DATE
  FIELD Beneficiado AS LOGICAL
  FIELD FechaBeneficio AS DATE
  
  {&EXTRA-FIELDS}
  INDEX pkFamilia IS PRIMARY IS UNIQUE CodEmpleado Nombre.  
