/* <%TRADUCCION%>{&SCOPE} se utiliza para definir la visibilidad de la definicin cuando la inclusin se hace en una clase
   {&ENV} permite agregar el caracter inicial que posibilita incluir varias veces la definicin con diferentes nombres
   {&REF-ONLY} se especifica como TRUE cuando la inclusin la realiza un BaseDAODelegate
   {&EXTRA-FIELDS} permite agregar campos a la definicin al momento de la inclusin. Se lo utiliza en los archivos de servicios</%TRADUCCION%>

   <%TRADUCCION%>Esta tabla es "hija" de Empleado y contendr los datos de los horarios de trabajo de cada empleado.</%TRADUCCION%> */
DEFINE {&SCOPE} TEMP-TABLE {&ENV}ttHorario NO-UNDO  &IF {&REF-ONLY} &THEN REFERENCE-ONLY &ENDIF
  BEFORE-TABLE {&ENV}ttbfHorario
  
   FIELD  CodEmpleado AS  INTEGER
   FIELD  DiaTrabajado AS  DATE 
   FIELD  TipoDia AS  CHARACTER
   FIELD  EntradaAM AS  CHARACTER  
   FIELD  SalidaAM AS  CHARACTER   
   FIELD  EntradaPM AS  CHARACTER  
   FIELD  SalidaPM AS  CHARACTER   
   FIELD  HorasRegulares AS  DECIMAL
   FIELD  HorasExtras AS  DECIMAL
  
  {&EXTRA-FIELDS}
  INDEX pkHorario IS PRIMARY IS UNIQUE CodEmpleado DiaTrabajado. /*clave primaria compuesta*/  

  