/* <%TRADUCCION%>{&SCOPE} se utiliza para definir la visibilidad de la definicin cuando la inclusin se hace en una clase
   {&ENV} permite agregar el caracter inicial que posibilita incluir varias veces la definicin con diferentes nombres
   {&REF-ONLY} se especifica como TRUE cuando la inclusin la realiza un BaseDAODelegate
   {&EXTRA-FIELDS} permite agregar campos a la definicin al momento de la inclusin. Se lo utiliza en los archivos de servicios
   
   Tabla "hija" de Documento.i, que contiene todos los detalles de cada documento.</%TRADUCCION%> */
DEFINE {&SCOPE} TEMP-TABLE {&ENV}ttLineaDocumento NO-UNDO  &IF {&REF-ONLY} &THEN REFERENCE-ONLY &ENDIF
  BEFORE-TABLE {&ENV}ttbfLineaDocumento
  FIELD Documento AS INTEGER
  FIELD Numero AS INTEGER INITIAL ?
  FIELD Articulo AS INTEGER
  FIELD Precio AS DECIMAL
  FIELD Cantidad AS INTEGER
  FIELD Descuento AS INTEGER
  FIELD PrecioExtendido AS DECIMAL
  FIELD Estado AS CHARACTER
  {&EXTRA-FIELDS}
  INDEX pkLineaDocumento IS PRIMARY IS UNIQUE Documento Numero
  INDEX ixArticulo IS UNIQUE Documento Articulo Precio Descuento
  INDEX ixEstado Estado.
