/* <%TRADUCCION%>{&SCOPE} se utiliza para definir la visibilidad de la definicin cuando la inclusin se hace en una clase
   {&ENV} permite agregar el caracter inicial que posibilita incluir varias veces la definicin con diferentes nombres
   {&REF-ONLY} se especifica como TRUE cuando la inclusin la realiza un BaseDAODelegate
   {&EXTRA-FIELDS} permite agregar campos a la definicin al momento de la inclusin. Se lo utiliza en los archivos de servicios</%TRADUCCION%>
   
   <%TRADUCCION%>Esta tabla complementa a Documento para formar la orden de venta</%TRADUCCION%> */
DEFINE {&SCOPE} TEMP-TABLE {&ENV}ttOrdenVenta NO-UNDO  &IF {&REF-ONLY} &THEN REFERENCE-ONLY &ENDIF
  BEFORE-TABLE {&ENV}ttbfOrdenVenta
  FIELD Numero AS INTEGER
  FIELD FechaEnvio AS DATETIME
  FIELD Comprometido AS DATETIME
  FIELD Transporte AS CHARACTER
  FIELD Instrucciones AS CHARACTER
  FIELD OrdenCompra AS CHARACTER  
  FIELD Condiciones AS CHARACTER
  FIELD RepresentanteDeVentas AS CHARACTER
  FIELD FacturarA AS INTEGER
  FIELD EnviarA AS INTEGER
  FIELD Almacen AS INTEGER
  FIELD TarjetaCredito AS CHARACTER
  {&EXTRA-FIELDS}
  INDEX pkOrdenVenta IS PRIMARY IS UNIQUE Numero
  INDEX ixEnvio FechaEnvio EnviarA
  INDEX ixVentas RepresentanteDeVentas Almacen
  INDEX ixCompromiso Comprometido.
