/* <%TRADUCCION%>{&SCOPE} se utiliza para definir la visibilidad de la definicin cuando la inclusin se hace en una clase
   {&ENV} permite agregar el caracter inicial que posibilita incluir varias veces la definicin con diferentes nombres
   {&REF-ONLY} se especifica como TRUE cuando la inclusin la realiza un BaseDAODelegate
   {&EXTRA-FIELDS} permite agregar campos a la definicin al momento de la inclusin. Se lo utiliza en los archivos de servicios</%TRADUCCION%> */
DEFINE {&SCOPE} TEMP-TABLE {&ENV}ttProveedor NO-UNDO  &IF {&REF-ONLY} &THEN REFERENCE-ONLY &ENDIF
  BEFORE-TABLE {&ENV}ttbfProveedor
  FIELD Codigo AS INTEGER INITIAL ?
  FIELD Pais AS CHARACTER
  FIELD Nombre AS CHARACTER
  FIELD Direccion AS CHARACTER
  FIELD DireccionAlternativa AS CHARACTER
  FIELD Ciudad AS CHARACTER
  FIELD Estado AS CHARACTER
  FIELD CodigoPostal AS CHARACTER
  FIELD Telefono AS CHARACTER
  FIELD PalabraClave AS CHARACTER
  FIELD Descuento AS INTEGER
  FIELD MontoEmbarque AS INTEGER
  FIELD Observaciones AS CHARACTER
  FIELD FechaIngreso AS DATETIME
  {&EXTRA-FIELDS}
  INDEX pkProveedor IS PRIMARY IS UNIQUE Codigo
  INDEX ixNombre Nombre Pais Estado Ciudad.
