/* <%TRADUCCION%>{&SCOPE} se utiliza para definir la visibilidad de la definicin cuando la inclusin se hace en una clase
   {&ENV} permite agregar el caracter inicial que posibilita incluir varias veces la definicin con diferentes nombres
   {&REF-ONLY} se especifica como TRUE cuando la inclusin la realiza un BaseDAODelegate
   {&EXTRA-FIELDS} permite agregar campos a la definicin al momento de la inclusin. Se lo utiliza en los archivos de servicios</%TRADUCCION%> */
DEFINE {&SCOPE} TEMP-TABLE {&ENV}ttRepresentanteVentas NO-UNDO  &IF {&REF-ONLY} &THEN REFERENCE-ONLY &ENDIF
  BEFORE-TABLE {&ENV}ttbfRepresentanteVentas
  FIELD Identificador AS CHARACTER
  FIELD Nombre AS CHARACTER
  FIELD Region AS CHARACTER
  FIELD CuotaCuatrimestre1 AS INTEGER EXTENT 4
  FIELD CuotaCuatrimestre2 AS INTEGER EXTENT 4
  FIELD CuotaCuatrimestre3 AS INTEGER EXTENT 4
  {&EXTRA-FIELDS}
  INDEX pkRepresentanteVentas IS PRIMARY IS UNIQUE Identificador
  INDEX ixNombre Nombre Region.
