/*
*********************************************************************
* Propiedad intelectual de NomadeSoft S.R.L. - Mendoza - Argentina  *
*                     - www.NomadeSoft.com.ar -                     *
*                   ____________________________                    *
*                                                                   *
* El codigo abierto esta basado en la generosidad, no la estupidez. *
* Sea amable, si utiliza o se inspira en este codigo, mencione al   *
* propietario y a sus autores.                                      *
*                                                                   *
*                              _____                                *
*                                                                   *
* Open Source is based on generosity, not stupidity. Be gentle, if  *
* you use or get inspired by this code, mention the owner and the   *
* authors.                                                          *
*                                                                   *
*********************************************************************
*/
function TableTreeView(Owner)
	{
	this.owner=Owner;
	this.rowCount=0;
	this.realCount = 0;
	this.firstrowKnown= false;
	this.lastrowKnown= false;
	this.rowdataStart=0;
	this.waterMark=0;
	this.rowdataEnd=-1;
	this.refdata=new Array();
	this.rowdata=new Array();
	this.potentialSortGroups=new Array();
	this.sortedCols=new Array();
	if(this.owner.labelfields[this.owner.labelfields.length-1]=='/')
		this.datacols=this.owner.labelfields.substr(0,this.owner.labelfields.length-1).split("/");
	else
		this.datacols = this.owner.labelfields.split("/");
	this.refcols = this.owner.reffield.split("/");
	this.properties = {};
	this.propertiesField = {};
	this.setPropFunc=function(cual,fp,userfunc){
		if(!fp && !userfunc)
			return;
		if(userfunc){
			this.propertiesField[cual] = true;
			this.properties[cual] = eval(userfunc);
		}else{
			var fps = fp.split(',');
			for(var i=0;i<this.datacols.length;i++){
				if(this.datacols[i] == fps[0]){
					fps.shift();
					this.propertiesField[cual] = Array(i,fps);
					break;
				};
			};
			if(this.propertiesField[cual]){
				this.properties[cual] = Array(this,null);
				this.inArray = function(que,donde){
					for(var i=0; i < donde.length; i++){
						if(que == donde[i])
							return true;
					};
					return false;
				};
				eval('this.properties[cual][1] = function(rowindex,colindex){try{if(isNaN(Number(rowindex))){var aux = rowindex;rowindex = colindex;colindex=aux};if((!colindex && colindex !== 0) || !this.propertiesField["'+cual+'"][1].length || this.inArray(colindex,this.propertiesField["'+cual+'"][1]))return this.rowdata[rowindex][this.propertiesField["'+cual+'"][0]];}catch(e){};return null;}');
			};
		};
	};
	this.setPropFunc('row',Owner.getAttribute('rowProperties'),Owner.getAttribute('rowPropertiesLogic'));
	this.setPropFunc('cell',Owner.getAttribute('cellProperties'),Owner.getAttribute('cellPropertiesLogic'));
	this.setPropFunc('col',Owner.getAttribute('colProperties'),Owner.getAttribute('colPropertiesLogic'));
};
TableTreeView.prototype.getProperties=function(cual,params){
	try{
		if(this.properties[cual])
			return this.properties[cual][1].apply(this.properties[cual][0],params);
	}catch(e){};
	return null;
};
TableTreeView.prototype.actionStart=function(actionId,descrip)
	{
	this.owner.actionStart(actionId,descrip);
	};
TableTreeView.prototype.fillRequest=function(request,searchdata,toretrieve,fromdata,dirdata)
	{
	request.setParameter("query","char,string",this.owner.query);
	if(searchdata)
		request.setParameter("search","char,string",searchdata);
	else
		request.setParameter("search","char,string");
	request.setParameter("labels","char,string",this.owner.labelfields);
	request.setParameter("reference","char,string",this.owner.reffield);
	if(toretrieve)
		request.setParameter("count","number,int",toretrieve);
	else
		request.setParameter("count","number,int",this.owner.retrieveCount);
	if(fromdata)
		request.setParameter("from","char,string",fromdata);
	else
		request.setParameter("from","char,string");
	if(dirdata)
		request.setParameter("retdir","char,string",dirdata);
	else
		request.setParameter("retdir","char,string",this.owner.defaultRetrieveDirection);
	return 7;
	};
TableTreeView.prototype.isEditable=function(row,col)
	{
	return true;
	};
TableTreeView.prototype.getCellText=function(row,col)
	{
	if(!this.rowCount)
		return "";
	try
		{
		if(row>this.rowdataEnd || row<this.rowdataStart)
			{
			if(!this.waitingAnswer)
				{
				if(row>this.rowdataEnd)
					this.retrieveData(row,'fwrd');
				else
					this.retrieveData(row,'bkwrd');
				};
			return "...";
			}
		else
			{
			if(this.treebox.columns)
				var colid=col.id;
			else
				var colid=col;
			var thecols=this.owner.getMyColumns();
			var i=0;
			while(i<thecols.length && thecols[i].getAttribute('id')!=colid)
				{
				i++;
				};
			return this.rowdata[row-this.rowdataStart][i];
			};
		}
	catch(e)
		{
		};
	return "";
    };
TableTreeView.prototype.retrieve=function(row)
	{
	if(row>=0 && row<this.realCount)
		{
		var realrow = this.tree.builderView.getItemAtIndex(row);
		if(realrow.hasAttribute('unknownRow'))
			{
			row = realrow.getAttribute('unknownRow');
			if(!this.waitingAnswer)
				{
				if(row == 0)
					this.retrieveData(this.rowdataStart,'bkwrd');
				else
					this.retrieveData(row+this.rowdataStart,'fwrd');
				};
			return true;
			};
		};
	return false;
	};
TableTreeView.prototype.setDOMRow=function(rowindex)
	{
	this.owner.resetingData = true;
	try
		{
		var rows = this.treebox.firstChild.nextSibling;
		if(!rows.childNodes.length)
			return;
		var row = rows.firstChild;
		var rowind = rowindex;
		var hasFirst = row.hasAttribute('unknownRow');
		if(hasFirst)
			rowindex++;
		if(rows.childNodes.length>rowindex)
			{
			row = rows.childNodes.item(rowindex).firstChild;
			if(this.properties['row'])
				row.setAttribute('properties',this.getProperties('row',[rowindex]));
			for(var i=0; i<row.childNodes.length; i++){
				var cell = row.childNodes.item(i);
				cell.setAttribute("label",this.rowdata[rowind][i]);
				if(this.properties['cell'])
					cell.setAttribute('properties',this.getProperties('cell',[rowindex,i]));
			};
			};
		}
	catch(e)
		{
		}
	finally
		{
		delete this.owner.resetingData;
		};
	};
TableTreeView.prototype.setDOMRows=function()
	{
	this.owner.resetingData = true;
	try
		{
		this.newRow=function(data,rowindex)
			{
			var item = document.createElement("treeitem");
			var row = document.createElement("treerow");
			try
				{
				for(var i=0;i<data.length; i++)
					{
					var elem = document.createElement("treecell");
					elem.setAttribute("label",data[i]);
					if(this.properties['cell'])
						elem.setAttribute('properties',this.getProperties('cell',[rowindex,i]));
					row.appendChild(elem);
					};
				if(this.properties['row'])
					row.setAttribute('properties',this.getProperties('row',[rowindex]));
				}
			catch(e){};
			item.appendChild(row);
			return item;
			};

		var currow = 0;
		var rows = this.treebox.firstChild.nextSibling;
		var hadFirst = false;
		if(rows.childNodes.length)
			{
			var row = rows.firstChild;
			hadFirst = row.hasAttribute('unknownRow');
			};
		if(!this.firstrowKnown || this.rowdataStart>0)
			{
			if(!rows.childNodes.length)
				rows.appendChild(this.newRow(this.rowdata[0],0));
			var row = rows.firstChild.firstChild;
			row.removeAttribute('properties');
			for(var i=0; i<row.childNodes.length; i++){
				var cell = row.childNodes.item(i);
				cell.setAttribute("label","+");
				cell.removeAttribute('properties');
			};
			currow++;
			if(!hadFirst)
				{
				row.parentNode.setAttribute('unknownRow',0);
				this.selectedRow++;
				};
			}
		else if(hadFirst)
			{
			row.removeAttribute('unknownRow');
			this.selectedRow--;
			};
		if(rows.childNodes.length>1)
			rows.lastChild.removeAttribute('unknownRow');
		var rowind = 0;
		while(rowind<this.rowdata.length)
			{
			if(currow >= rows.childNodes.length)
				rows.appendChild(this.newRow(this.rowdata[rowind],rowind));
			else
				{
				var row = rows.childNodes.item(currow).firstChild;
				if(this.properties['row'])
					row.setAttribute('properties',this.getProperties('row',[rowind]));
				for(var i=0; i<row.childNodes.length; i++){
					var cell = row.childNodes.item(i);
					cell.setAttribute("label",this.rowdata[rowind][i]);
					if(this.properties['cell'])
						cell.setAttribute('properties',this.getProperties('cell',[rowind,i]));
				};
				};
			currow++;
			rowind++;
			};
		if(!this.lastrowKnown || (this.rowdataEnd<this.rowCount-1 && this.firstrowKnown || this.rowdataEnd<this.rowCount-2))
			{
			if(currow >= rows.childNodes.length)
				rows.appendChild(this.newRow(this.rowdata[rowind-1],rowind-1));
			var row = rows.childNodes.item(currow).firstChild;
			row.removeAttribute('properties');
			for(var i=0; i<row.childNodes.length; i++){
				var cell = row.childNodes.item(i);
				cell.setAttribute("label","+");
				cell.removeAttribute('properties');
			};
			row.parentNode.setAttribute('unknownRow',rowind-1);
			currow++;
			}
		while(rows.childNodes.length > currow)
			rows.removeChild(rows.lastChild);

		this.realCount = rows.childNodes.length;
		}
	catch(e)
		{
		}
	finally
		{
		delete this.owner.resetingData;
		};
	};

TableTreeView.prototype.setTreeHack=function(treebox)
	{
	if(treebox)
		{
		this.treebox = treebox.view.selection.tree;
		this.tree = treebox;
		this.selection = treebox.view.selection;
		}
	else
		{
		delete this.treebox;
		delete this.tree;
		delete this.selection;
		};
	};
TableTreeView.prototype.setTree=function(treebox)
	{
	if(treebox)
		{
		if(!this.treebox)
			this.treebox = treebox;
		if(this.owner.labelfields[this.owner.labelfields.length-1]=='/')
			this.datacols=this.owner.labelfields.substr(0,this.owner.labelfields.length-1).split("/");
		else
			this.datacols = this.owner.labelfields.split("/");
		this.refcols = this.owner.reffield.split("/");
		this.rowCount=0;
		this.realCount = 0;
		this.firstrowKnown=false;
		this.lastrowKnown=false;
		this.waterMark=0;
		this.rowdataStart=0;
		this.rowdataEnd=-1;
		if(treebox && this.owner.headerClick)
			{
			var cols=this.owner.getMyColumns();
			if(cols)
				{
				this.columnclick={
					view:this,
					handleEvent:function(event)
						{
						if(!this.view.owner.hasAttribute('disabled'))
							{
							if(this.view.treebox.columns)
								this.view.cycleHeader(event.target);
							else
								this.view.cycleHeader(event.target.id);
							};
						}
					}
				for(var i=0;i<cols.length;i++)
					cols[i].addEventListener('click',this.columnclick,true);
				};
			};
		}
	else
		{
		if(this.treebox && this.owner && this.owner.headerClick)
			{
			var cols=this.owner.getMyColumns();
			if(cols)
				{
				for(var i=0;i<cols.length;i++)
					cols[i].removeEventListener('click',this.columnclick,true);
				};
			};
		delete this.columnclick;
		delete this.owner;
		delete this.refdata;
		delete this.rowdata;
		delete this.potentialSortGroups;
		delete this.sortedCols;
		delete this.datacols;
		delete this.refcols;
		if(this.CommProt)
			this.CommProt.destroy();
		delete this.CommProt;
		};
	};
TableTreeView.prototype.reset=function()
	{
	if(this.CommProt)
		this.CommProt.reset("serverAnswer");
	this.owner.actionEnd('retrieve');
	delete this.refdata;
	this.refdata=new Array();
	delete this.rowdata;
	this.rowdata=new Array();
	this.rowdataStart=0;
	this.rowdataEnd=-1;
	this.treebox.beginUpdateBatch();
	this.rowCount=0;
	this.realCount = 0;
	this.waterMark=0;
	this.firstrowKnown=false;
	this.lastrowKnown=false;
	if(_FIREFOX_VERSION_>=1.5)
		{
		var rows = this.treebox.firstChild.nextSibling;
		while(rows.hasChildNodes())
			rows.removeChild(rows.lastChild);
		};
	this.treebox.endUpdateBatch();
	if(this.owner.prevfilter && !this.owner.filtering)
		this.owner.prevfilter='';
	this.owner.selectionChange();
	};
TableTreeView.prototype.pivot=function(row)
	{
	if(row<this.rowdataStart)
		row=this.treebox.getFirstVisibleRow();
	if(row>this.rowdataEnd)
		row=this.treebox.getLastVisibleRow();
	if(row<this.rowdataStart)
		row=this.rowdataStart;
	if(row>this.rowdataEnd)
		row=this.rowdataEnd;
	if(this.refdata.length)
		this.pivotref=this.refdata[row-this.rowdataStart];
	if(this.rowdata.length)
		this.pivotdata=this.rowdata[row-this.rowdataStart];
	this.focusRefRow=true;
	this.reset();
	if(this.owner.retrieveCount>0 && this.owner.retrieveCount<this.treebox.getLastVisibleRow())
		this.owner.retrieveCount=this.treebox.getLastVisibleRow()+2;
	if(row<0)
		this.retrieveData();
	else
		this.retrieveData(row,'middle');
	};
TableTreeView.prototype.isContainer=function(row)
	{
	return false;
	};
TableTreeView.prototype.isSeparator=function(row)
	{
	return false;
	};
TableTreeView.prototype.isSorted=function()
	{
	return true;
	};
TableTreeView.prototype.getLevel=function(row)
	{
	return 0;
	};
TableTreeView.prototype.getImageSrc=function(row,col)
	{
	return null;
	};
TableTreeView.prototype.getRowProperties=function(row,props)
	{
		props.value = this.getProperties('row',[row]);
	};
TableTreeView.prototype.getCellProperties=function(row,col,props)
	{
		props.value = this.getProperties('cell',[row,col]);
	};
TableTreeView.prototype.getColumnProperties=function(colid,col,props)
	{
		props.value = this.getProperties('col',[colid,col]);
	};
TableTreeView.prototype.cycleHeader=function(col)
	{
	if(this.owner.headerClick && !this.waitingAnswer)
		{
		if(this.treebox.columns)
			var colid=col.id;
		else
			var colid=col;
		var thecols=this.owner.getMyColumns();
		var i=0;
		while(i<thecols.length && thecols[i].getAttribute('id')!=colid)
			i++;
		if(this.owner.headerSort)
			{
			this.owner.sort(this.owner.id,this.datacols[i]);
			}
		else if(thecols[i].hasAttribute('sortDirection'))
			{
			if(thecols[i].getAttribute('sortDirection')=='ascending')
				thecols[i].setAttribute('sortDirection','descending');
			else
				thecols[i].setAttribute('sortDirection','ascending');
			this.owner.applySort();
			};
		};
	};
TableTreeView.prototype.retrieveData=function(from,rettype)
	{
	this.owner.actionStart('retrieve',"dataPumpStartMsg");
	if(this.owner.preRetrieve)
		{
		var retdata={from:0,rettype:""};
		retdata.from=from;
		retdata.rettype=rettype;
		this.owner.preRetrieve(retdata);
		from=retdata.from;
		rettype=retdata.rettype;
		};
	var toretrieve=0;
	var hastodelete=0;
	var minret=0;
	try
		{
		if(!this.CommProt)
			{
			this.CommProt=new NSCommProtocol(this,"serverAnswer","IWillDoTheParsing",'tableread');
			if(this.owner && this.owner.isSignal)
				this.owner.commProt = this.CommProt;
			}
		else
			{
			this.CommProt.reset("serverAnswer");
			if( this.pivotref && ( ( from==null ) || ( from==undefined ) ) )
				{
				delete this.pivotref;
				delete this.pivotdata;
				};
			};
		this.CommProt.setProxyService(this.owner.targetURL);
		this.CommProt.setSession(this.owner.sessionId);
		if(this.owner.linkedService)
			this.CommProt.setService(this.owner.linkedService);
		if(!this.owner.retrieveCount)
			this.owner.retrieveCount=0;
		this.retdirection=1;
		if(rettype)
			{
			if(rettype=="middle")
				this.retdirection=0;
			else if(rettype=="bkwrd")
				this.retdirection=-1;
			};
		toretrieve=Number(this.owner.retrieveCount);
		if((from!=null && from!=undefined) && this.owner.maxLocalBuffer)
			{
			if(this.firstrowKnown && this.lastrowKnown)
				{
				if(toretrieve>0)
					{
					if(this.retdirection>0)
						hastodelete=this.rowdataEnd-this.treebox.getFirstVisibleRow();
					else if(this.retdirection<0)
						hastodelete=this.treebox.getLastVisibleRow()-this.rowdataStart;
					hastodelete++;
					hastodelete-=this.owner.maxLocalBuffer-toretrieve;
					if(hastodelete>0)
						{
						toretrieve-=hastodelete;
						if(this.retdirection>=0)
							minret=Number(this.treebox.getLastVisibleRow())-Number(this.rowdataEnd);
						if(this.retdirection<=0)
							minret+=this.rowdataStart-this.treebox.getFirstVisibleRow();
						minret++;
						if(minret>toretrieve)
							{
							this.owner.maxLocalBuffer=Number(this.owner.maxLocalBuffer-toretrieve)+minret;
							toretrieve=minret;
							};
						};
					};
				}
			else if(this.owner.maxLocalBuffer<toretrieve*3)
				{
				this.owner.maxLocalBuffer=toretrieve*3;
				minret=Number(this.treebox.getLastVisibleRow())-Number(this.treebox.getFirstVisibleRow())+Number(toretrieve);
				if(minret<50 && this.owner.maxLocalBuffer<minret)
					{
					this.owner.maxLocalBuffer=minret;
					};
				};
			};
		var fromdata = null;
		var dirdata = null;
		if((from!=null && from!=undefined) || rettype)
			{
			if(from!=null && from!=undefined)
				{
				if(from>this.rowdataEnd)
					this.waitingStart=this.refdata.length-1;
				else
					this.waitingStart=0;
				if(this.pivotref)
					fromdata = this.pivotref;
				else if(this.refdata.length)
					fromdata = this.refdata[this.waitingStart];
				}
			else if(this.retdirection>0)
				this.waitingStart=0;
			else
				this.waitingStart=this.waterMark;
			if(rettype)
				dirdata = rettype;
			}
		else
			{
			if(this.waitingStart)
				delete this.waitingStart;
			delete this.rowdata;
			this.rowdata=new Array();
			delete this.refdata;
			this.refdata=new Array();
			};
		this.fillRequest(this.CommProt,null,toretrieve,fromdata,dirdata);
		if(toretrieve==0)
			toretrieve=-1;
		this.waitingAnswer=Number(toretrieve);
		if(this.owner.commRetained)
			{
			this.CommProt.pendingAction = "dataPumpStartMsg";
			this.CommProt.pendingActionId = 'retrieve';
			this.owner.actionEnd('retrieve');
			};
		this.CommProt.send();
		delete this.owner.sendFailed;
		}
	catch(e)
		{
		alert("TableTreeView::retrieveData() -"+e);
		};
	};
TableTreeView.prototype.serverAnswer=function(comm,useThis)
	{
	try
		{
		var frpos=0;
		var resp=useThis;
		if(!resp)
			var resp=this.CommProt.getXML();
		resp=resp.substr(resp.indexOf('<answers>')+9);
		resp=getContent(resp,nextTagName(resp,0),0);
		var auxind=0;
		var aux="";
		var data={};
		var name=nextTagName(resp,0);
		getTagStartEnd(resp,name,0,data);
		name=resp.substring(data.start,data.end+1);
		if(this.rowCount==0)
			{
			auxind=name.indexOf('rowcount="');
			if(!this.firstrowKnown && !this.lastrowKnown && (auxind>0))
				{
				this.waterMark=0;
				auxind+=10;
				if(this.pivotdata)
					{
					frpos=name.indexOf('startpos="');
					if(frpos>0)
						{
						aux=name.substr(auxind,name.indexOf('" ')-auxind);
						frpos+=10;
						this.rowCount=aux;
						this.firstrowKnown=true;
						this.lastrowKnown=true;
						aux=name.substr(frpos,name.indexOf('">')-frpos);
						this.rowdataStart=aux;
						this.rowdataEnd=aux-1;
						};
					}
				else
					{
					if(name.indexOf('">')<0)
						aux=name.substr(auxind,name.indexOf('"/>')-auxind);
					else
						aux=name.substr(auxind,name.indexOf('">')-auxind);
					this.rowCount=aux;
					this.firstrowKnown=true;
					this.lastrowKnown=true;
					if(this.retdirection<0)
						{
						if(this.rowCount)
							{
							this.treebox.scrollToRow(this.rowCount-(this.treebox.getLastVisibleRow()-this.treebox.getFirstVisibleRow()));
							this.selection.select(this.rowCount-1);
							};
						this.rowdataEnd=this.rowCount-1;
						this.rowdataStart=this.rowCount;
						};
					};
				}
			else if(this.waterMark==0)
				{
				if(this.retdirection<0)
					{
					this.lastrowKnown=true;
					this.selection.select(0);
					}
				else if(this.retdirection>0)
					this.firstrowKnown=true;
				};
			};
		resp=resp.substr(data.end+1);
		var colnames=new Array();
		if(!this.owner.tableStructure)
			{
			this.owner.tableStructure = new Array();
			aux=getContent(name,nextTagName(name,0),0);
			while(aux.length)
				{
				name=nextTagName(aux,0);
				getTagStartEnd(aux,name,0,data);
				colnames.push(name);
				var tg = aux.substr(data.start,data.end-data.start);
				var coltype = "";
				var colsubtype = "";
				var tp = tg.indexOf("type");
				if(tp>0)
					{
					tp += 6;
					coltype = tg.substr(tp,tg.indexOf(tg[tp-1],tp)-tp);
					};
				tp = tg.indexOf("subtype");
				if(tp>0)
					{
					tp += 9;
					colsubtype = tg.substr(tp,tg.indexOf(tg[tp-1],tp)-tp);
					};
				this.owner.tableStructure.push([name,coltype,colsubtype]);
				aux=aux.substr(data.end+1);
				};
			}
		else
			{
			for(var i=0; i<this.owner.tableStructure.length;i++)
				colnames.push(this.owner.tableStructure[i][0]);
			};
		var rows=new Array();
		while(resp.length > 3)
			{
			name=nextTagName(resp,0);
			aux=getContent(resp,name,0);
			getTagStartEnd(resp,name,0,data);
			resp=resp.substr(data.end+1);
			if(name=="refrow")
				{
				if(aux!='' && this.pivotref)
					{
					var arr=new Array();
					name=nextTagName(aux,0);
					for(var i=0;i<colnames.length;i++)
						{
						if(!aux.length || name!=colnames[i])
							arr.push(null);
						else
							{
							arr.push(getNextContent(aux,0));
							getTagStartEnd(aux,name,0,data);
							aux=aux.substr(data.end+1);
							name=nextTagName(aux,0);
							};
						};
					this.pivotref = arr.pop();
					this.pivotdata = arr;
					}
				else if(aux == '' && this.owner.hasAttribute('preferServer'))
					{
					delete this.pivotref;
					delete this.pivotdata;
					};
				rows.push(null);
				}
			else
				{
				var arr=new Array();
				name=nextTagName(aux,0);
				for(var i=0;i<colnames.length;i++)
					{
					if(!aux.length || name!=colnames[i])
						arr.push(null);
					else
						{
						arr.push(getNextContent(aux,0));
						getTagStartEnd(aux,name,0,data);
						aux=aux.substr(data.end+1);
						name=nextTagName(aux,0);
						};
					};
				rows.push(arr);
				};
			};
		if(this.waitingAnswer>0 && rows.length>this.waitingAnswer+1)
			{
			if(this.retdirection==0)
				{
				i=0;
				while(rows[i])
					i++;
				auxind=this.waitingAnswer/2;
				while(i>auxind)
					{
					rows.shift();
					i--;
					};
				while(rows.length>this.waitingAnswer+1)
					rows.pop();
				}
			else if(this.retdirection>0)
				{
				while(rows.length>this.waitingAnswer+1)
					rows.pop();
				}
			else
				{
				while(rows.length>this.waitingAnswer+1)
					rows.shift();
				};
			};
		this.fillRowData(this.owner.applyLocalChanges(rows));
		}
	catch(e)
		{
		alert("TableTreeView::serverAnswer() -"+e);
		};
	delete this.waitingAnswer;
	this.owner.actionEnd('retrieve',"dataPumpEndMsg");
	};
TableTreeView.prototype.fillRowData=function(rows)
	{
	if(this.treebox)
		{
		this.updating=true;
		this.treebox.beginUpdateBatch();
		};
	try
		{
		this.selectedRow=this.selection.currentIndex;
		var prevpos=this.selectedRow;
		var curmax=this.owner.maxLocalBuffer || 0;
		var i=0;
		if(!this.waitingStart || this.waitingStart<0)
			this.waitingStart=0;
		if(!this.firstrowKnown && this.rowdataStart==1)
			{
			this.rowCount--;
			this.rowdataStart--;
			this.rowdataEnd--;
			if(_FIREFOX_VERSION_<1.5)
				this.selectedRow--;
			prevpos--;
			};
		if(!this.lastrowKnown && this.rowCount>0)
			this.rowCount--;
		var lowseen=0;
		var selRowAdded = false;
		for(i=0;i<rows.length;i++,lowseen++)
			{
			if(!rows[i])
				{
				if(this.pivotref)
					{
					this.refdata.push(this.pivotref);
					this.rowdata.push(this.pivotdata);
					delete this.pivotref;
					delete this.pivotdata;
					if(this.rowdataStart)
						this.rowdataStart--;
					else
						{
						this.rowdataEnd++;
						this.waterMark++;
						};
					};
				if(this.focusRefRow)
					{
					this.selectedRow=i;
					};
				rows.splice(i,1);
				break;
				};
			var newrow=rows[i];
			this.refdata.splice(this.waitingStart,0,newrow.pop());
			this.rowdata.splice(this.waitingStart++,0,newrow);
			if(this.rowdataStart)
				{
				this.rowdataStart--;
				selRowAdded = false;
				}
			else
				{
				selRowAdded = true;
				this.rowdataEnd++;
				this.waterMark++;
				this.selectedRow++;
				prevpos++;
				};
			if(curmax && this.rowdata.length>curmax)
				{
				if(_FIREFOX_VERSION_>=1.5 && !selRowAdded)
					this.selectedRow++;
				this.rowdata.pop();
				this.refdata.pop();
				this.rowdataEnd--;
				};
			};
		var highseen=0;
		for(;i<rows.length;i++,highseen++)
			{
			var newrow=rows[i];
			this.refdata.push(newrow.pop());
			this.rowdata.push(newrow);
			this.rowdataEnd++;
			if(this.rowdataEnd>=this.waterMark)
				{
				this.waterMark++;
				};
			if(curmax && this.rowdata.length>curmax)
				{
				if(_FIREFOX_VERSION_>=1.5)
					this.selectedRow--;
				this.rowdata.shift();
				this.refdata.shift();
				this.rowdataStart++;
				};
			};
		if((!this.firstrowKnown || !this.lastrowKnown)&& this.rowCount!=this.waterMark)
			{
			this.rowCount=this.waterMark;
			}
		else if(!this.rowCount && this.waterMark)
			this.rowCount = this.waterMark;
		if(!this.firstrowKnown)
			{
			this.firstrowKnown=(this.waitingAnswer<0)||((lowseen<Math.round(this.waitingAnswer/2)-1) && (this.retdirection<=0))||(lowseen<this.waitingAnswer && this.retdirection<0);
			if(this.firstrowKnown)
				{
				this.owner.rowselect(null);
				};
			};
		if(!this.lastrowKnown)
			{
			this.lastrowKnown=(this.waitingAnswer<0)||((highseen<Math.round(this.waitingAnswer/2)-1) && (this.retdirection>=0))||(highseen<this.waitingAnswer && this.retdirection>0);
			};
		if(_FIREFOX_VERSION_>=1.5)
			this.setDOMRows();
		if(!this.lastrowKnown && this.rowdataEnd==this.rowCount-1)
			this.rowCount++;
		if(!this.firstrowKnown && this.rowdataStart==0)
			{
			this.rowCount++;
			this.rowdataStart++;
			this.rowdataEnd++;
			if(_FIREFOX_VERSION_<1.5)
				this.selectedRow++;
			prevpos++;
			if(this.treebox.getFirstVisibleRow()==0)
				{
				this.treebox.scrollToRow(1);
				};
			};
		if(_FIREFOX_VERSION_<1.5)
			this.realCount = this.rowCount;
		if(this.focusRefRow)
			{
			delete this.focusRefRow;
			if(this.owner.setFocusedRow)
				this.selectedRow=this.owner.setFocusedRow(this.selectedRow);
			};
		if(this.selectedRow<0)
			this.selectedRow=0;
		else if(this.selectedRow>=this.realCount)
			this.selectedRow=this.realCount-1;
		if(this.selection.currentIndex!=this.selectedRow)
			{
			if(this.selectedRow>=0)
				this.selection.select(this.selectedRow);
			if(this.selectedRow!=prevpos || _FIREFOX_VERSION_>=1.5)
				{
				this.treebox.ensureRowIsVisible(this.selectedRow);
				};
			};
		if(this.owner.stickToRow)
			this.treebox.ensureRowIsVisible(this.selection.currentIndex);
		lowseen=this.waitingStart+this.rowdataStart-lowseen;
		highseen+=this.waitingStart+this.rowdataStart;
		if(lowseen<=this.owner.lastselection && highseen>=this.owner.lastselection)
			delete this.owner.lastselection;

		this.owner.selectionChange();
		delete this.selectedRow;
		}
	catch(e)
		{
		};
	if(this.updating)
		{
		delete this.updating;
		this.treebox.endUpdateBatch();
		this.treebox.invalidate();
		};
	};
TableTreeView.prototype.goTo=function(condition)
	{
	if(this.waitingAnswer)
		{
		this.owner.emit("searchFailure");
		this.owner.actionEnd('search',"searchFailureMsg");
		return;
		};
	try
		{
		this.waitingAnswer=1;
		if(!this.CommProt)
			{
			this.CommProt=new NSCommProtocol(this,"searchAnswer","IWillDoTheParsing",'tablesearch');
			if(this.owner && this.owner.isSignal)
				this.owner.commProt = this.CommProt;
			}
		else
			this.CommProt.reset("searchAnswer");
		this.CommProt.setProxyService(this.owner.targetURL);
		this.CommProt.setSession(this.owner.sessionId);
		if(this.owner.linkedService)
			this.CommProt.setService(this.owner.linkedService);
		if(!this.owner.retrieveCount)
			this.owner.retrieveCount=0;
		this.retdirection=0;
		this.fillRequest(this.CommProt,condition,null,null,"middle");
		this.CommProt.send();
		delete this.owner.sendFailed;
		}
	catch(e)
		{
		alert("TableTreeView::goTo() -"+e);
		};
	};
TableTreeView.prototype.searchAnswer=function()
	{
	try
		{
		var resp = this.CommProt.getXML();
		resp=resp.substr(resp.indexOf('<answers>'));
		var refind=resp.indexOf('refrow');
		if(refind>0)
			{
			refind+=6;
			resp=resp.substr(0,refind)+"/><row"+resp.substr(refind,resp.indexOf('refrow',refind)-refind)+'row'+resp.substr(resp.indexOf('refrow',refind)+6);
			this.reset();
			if(this.owner.retrieveCount==0)
				this.waitingAnswer=-1;
			else
				this.waitingAnswer=Number(this.owner.retrieveCount);
			this.focusRefRow=true;
			this.owner.blockSignals = true;
			try
				{
				this.serverAnswer(this.CommProt,resp);
				}
			finally
				{
				this.owner.blockSignals = false;
				};
			this.owner.selectionChange(true);
			this.owner.emit("searchSuccess");
			this.owner.actionEnd('search',"searchSucessMsg");
			}
		else
			{
			this.owner.emit("searchFailure");
			this.owner.actionEnd('search',"searchFailureMsg");
			};
		}
	catch(e)
		{
		alert("TableTreeView::searchAnswer() -"+e);
		};
	delete this.waitingAnswer;
	};
