{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING icomun.dao.GenericServiceDelegate.
USING icomun.dao.SessionManager.
USING nsra.utiles.excepciones.Exception.
USING sports.dao.DocumentoConDetalle.

/*
Generic implementation of a "document line", used for Order and PurchaseOrder.
*/   
CLASS sports.dao.LineaDocumento INHERITS GenericServiceDelegate:
 
  /* TT definition. ref-only?? */

  /* properties to access internal fields */
  DEFINE PUBLIC PROPERTY cinNumero AS INTEGER  NO-UNDO /* cinNumber */
   	GET():
    END GET.

  DEFINE PUBLIC PROPERTY cchEstado AS CHARACTER NO-UNDO /* cchStatus */
   	GET():
    END GET.
    SET():
    END SET.
  	
  /* do your thing.. don't forget about uids */
  CONSTRUCTOR PUBLIC LineaDocumento(INPUT ipobOwner AS CLASS DocumentoConDetalle, INPUT TABLE cttLineaDocumento BIND, INPUT ipobSessionManager AS CLASS SessionManager):
  END CONSTRUCTOR.

  CONSTRUCTOR PUBLIC LineaDocumento(INPUT ipobOwner AS CLASS DocumentoConDetalle, INPUT TABLE cttLineaDocumento BIND, INPUT ipobSessionManager AS CLASS SessionManager, INPUT iphnRelation AS HANDLE):
  END CONSTRUCTOR.

  /* calculate the amount, given a quantity (ipinCantidad), a price (ipdcPrecio) and a discount (ipdcDescuento) */
  METHOD PUBLIC DECIMAL CalcularTotal(INPUT ipinCantidad AS INTEGER, INPUT ipdcPrecio AS DECIMAL, INPUT ipdcDescuento AS DECIMAL):
  END METHOD.
  
  /* apply a discount (ipdcDescuento) to all the lines of a document (ipinDocumento) */
  METHOD PUBLIC VOID AplicarDescuento(INPUT ipinDocumento AS INTEGER, INPUT ipdcDescuento AS DECIMAL):
    /* TIP: you are CHANGING the internal TT */
  END METHOD.
  
  /* calculate the amount of the document (ipinDocumento), it is, the SUM(document lines amount) */  
  METHOD PUBLIC DECIMAL TotalGeneral(INPUT ipinDocumento AS INTEGER):
  END METHOD.

  /* CRUD over line, check it */
  METHOD PUBLIC OVERRIDE VOID AssignValues(INPUT iphbBuffer AS HANDLE, INPUT ipchFieldMap AS CHARACTER):
    /* check you receive everything you need */
    
    /* are you happy by leaving the amount calculation to someone else? then do something!! */
  END METHOD.
END CLASS.
