{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING icomun.dao.GenericServiceDelegate.
USING icomun.dao.SessionManager.
USING nsra.utiles.excepciones.Exception.
USING sports.dao.DocumentoConDetalle.

/*
Generic implementation of a "document line", used for Order and PurchaseOrder.
*/   
CLASS sports.dao.LineaDocumento INHERITS <?>:
 
  /* calculate the amount, given a quantity (ipinCantidad), a price (ipdcPrecio) and a discount (ipdcDescuento) */
  METHOD PUBLIC DECIMAL CalcularTotal(INPUT ipinCantidad AS INTEGER, INPUT ipdcPrecio AS DECIMAL, INPUT ipdcDescuento AS DECIMAL):
  END METHOD.
  
  /* apply a discount (ipdcDescuento) to all the lines of a document (ipinDocumento) */
  METHOD PUBLIC VOID AplicarDescuento(INPUT ipinDocumento AS INTEGER, INPUT ipdcDescuento AS DECIMAL):
  END METHOD.
  
  /* calculate the amount of the document (ipinDocumento), it is, the SUM(document lines amount) */  
  METHOD PUBLIC DECIMAL TotalGeneral(INPUT ipinDocumento AS INTEGER):
  END METHOD.

END CLASS.
