{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING sports.dao.DocumentoConDetalle.
USING icomun.dao.SessionManager.
USING nsra.utiles.excepciones.Exception.
USING sports.dao.Proveedor.

/*
Purchase order implementation, making it part of the Documento (document) hierarchy.
*/
CLASS sports.dao.OrdenCompra INHERITS <which Documento CLASS should it inherit from?>:

  /*
  When dataset (dynamic) gets created, you need to add the tables defined in
  this class to the dataset.
  */
  METHOD PROTECTED OVERRIDE VOID CreateDataSet():
    /* check 'clgSplittedBuffer' BaseDAO feature */
  END METHOD.

  /*
  This method is invoked when the logical Temp-Table of the class is splitted in more than
  one buffer, each class in the inheritance tree is responsible for copying its "piece" of
  the data. 
  */
  METHOD PROTECTED OVERRIDE VOID CopySplittedBuffer(INPUT iphbDestino AS HANDLE,INPUT iphbSource AS HANDLE):
  END METHOD.

  /* you have to create your piece of the puzzle */
  METHOD PUBLIC OVERRIDE ROWID CreateIt():
  END METHOD.

  /* delete your piece of the puzzle */
  METHOD PUBLIC OVERRIDE ROWID DeleteIt():
  END METHOD.

  /* trick (maybe "hack") to be able to have one DSO class for more than one DAO TT */
  METHOD PROTECTED OVERRIDE CHARACTER SoyUn():
    RETURN 'PurchaseOrder'.
  END METHOD.

  /* someone doing CRUD, check it */
	METHOD PUBLIC OVERRIDE VOID AssignValues ( iphbBuffer AS HANDLE, ipchFieldMap AS CHARACTER ):
	END METHOD.
	
	/* calculate the total amount of the order (SUM of the lines) */
  METHOD PUBLIC DECIMAL Monto():
  END METHOD.
END CLASS.
