{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING icomun.dao.GenericServiceDAO.
USING icomun.dao.SessionManager.
USING nsra.utiles.excepciones.Exception.
USING sports.dao.Departamento.
USING sports.dao.Horario.
USING sports.dao.Vacaciones.
USING sports.dao.Familia.
USING sports.dao.Beneficio.
USING nsra.dao.BaseDAODelegate.

/*
Implements Employee business entity, which has its own data and the data of its
"delegates": 
          Horario
          Vacaciones
          Familia
  
Benefits should be also a "delegate" of Employee, but being a DEMO it was defined as a
main entity, to show the model capabilities
*/
CLASS sports.dao.Empleado INHERITS <who?>:
  /*
  TEMP-TABLEs definitions
  */
  
  /*
  DATASET definition, to handle all the temp-tables
  */
  DEFINE PROTECTED DATASET cpdEmpleado FOR /* missing tts here */
   /* missing data relations here */
  {&END} 

  /*
  Properties to access entity attributes (tt fields)
  */
    
  /*
  Department is another business entity of the system. So you may need to
  get the entity related to the employee, and not just the "code" of it.
  ATTENTION: each request will return a "different?" object, that can
  be ok or not, that's up to you.
  */
  DEFINE PUBLIC PROPERTY cobDepartment AS CLASS Departamento NO-UNDO
    GET():
      /* get an instance and fill it with the right data entity */
    END GET.
    
  /*
  "delegates" objects needs to be instantiated to gain access to related temp-tables,
  but they can only be instantiated by a main object.
  You need properties to access them!
  */
  DEFINE PUBLIC PROPERTY cobHorario AS CLASS Horario NO-UNDO /* timesheet */
    GET():
      DEFINE VARIABLE mobTmp AS CLASS BaseDAODelegate NO-UNDO. 
      mobTmp = FirstDelegate('sports.dao.Horario').
      IF mobTmp EQ ? THEN
         <now what?>.
      RETURN <what?>.
    END GET.
    
    /* add missing properties to other delagete classes */
  
  CONSTRUCTOR PUBLIC Empleado():
    /*
    Remember about cchSequencedFields.
    */
	END CONSTRUCTOR.

  CONSTRUCTOR PUBLIC Empleado(INPUT ipobSessionManager AS CLASS SessionManager):
	END CONSTRUCTOR.
	
  CONSTRUCTOR PUBLIC Empleado(INPUT ipchFiltro AS CHARACTER, INPUT ipobSessionManager AS CLASS SessionManager):
	END CONSTRUCTOR.

  /*
  Generic service assignment. Time to verify everything is in place to actually assign the internal
  temp-table fields. 
  */
	METHOD PUBLIC OVERRIDE VOID  AssignValues( iphbBuffer AS HANDLE, ipchFieldMap AS CHARACTER ):
	  /* verify required fields are provided */
	  
    SUPER:assignValues(iphbBuffer, ipchFieldMap).

    /* If this is a creation, then you need to create the benefits too (empty benefits) */
    
    <tt empleado name>.<main FIELD name> = ?. /* make sure a new one is being created */

    /* save changes, so you get the new employee code */
    IF NOT SaveChanges() THEN
      RETURN.
    /* locate the employee you just created and use it to create the benefits */
    
    FINALLY:
      /* never forget to release objects */
    END FINALLY. 
	END METHOD.
	
	/*
	do you need this??
  */
	METHOD PUBLIC OVERRIDE ROWID CreateIt():
	END METHOD.
END CLASS.