{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING sports.dao.Documento.
USING icomun.dao.SessionManager.
USING nsra.dao.BaseDAODelegate.
USING nsra.utiles.excepciones.Exception.
USING sports.dao.LineaDocumento.
USING nsra.dso.IBasicDataSource.

/****
 * clase 'abstracta' para implementar la lgica comn a todos los documentos que tienen lneas, es decir, detalle
 ****/

CLASS sports.dao.DocumentoConDetalle INHERITS Documento:
  {sports/tablas/LineaDocumento.i &SCOPE=PROTECTED &ENV=c}

  METHOD PROTECTED LineaDocumento CrearDetalle():
    RETURN NEW LineaDocumento(THIS-OBJECT, INPUT TABLE cttLineaDocumento BIND, cobSessionManager).
  END METHOD.

  DEFINE PUBLIC PROPERTY cobDetalle AS CLASS LineaDocumento NO-UNDO
    GET():
      DEFINE VARIABLE mobDetalle AS CLASS BaseDAODelegate NO-UNDO.
      mobDetalle = FirstDelegate("sports.dao.LineaDocumento").
      IF mobDetalle EQ ? THEN
        RETURN CrearDetalle().
      RETURN CAST(mobDetalle,LineaDocumento).
    END GET.

  /*********
   * determinar el origen de los datos del documento
   **********/
  METHOD PROTECTED OVERRIDE VOID PreSetDSO(INPUT ipobDSO AS CLASS IBasicDataSource,INPUT iphnBuffer AS HANDLE):
    SUPER:PreSetDSO(ipobDSO,iphnBuffer).
    IF iphnBuffer:TABLE EQ BUFFER cttLineaDocumento:HANDLE:TABLE  THEN
      CAST(ipobDSO,sports.dso.LineaDocumento):cchDataSource = SoyUn().
  END METHOD.

  /**
   *
   */
  METHOD PROTECTED OVERRIDE VOID CreateDataSet():
    SUPER:CreateDataSet().
    chdDocumento:ADD-BUFFER(BUFFER cttLineaDocumento:HANDLE).
    chdDocumento:ADD-RELATION(BUFFER cttDocumento:HANDLE,BUFFER cttLineaDocumento:HANDLE,'Numero,Documento').
  END METHOD.

  CONSTRUCTOR PUBLIC DocumentoConDetalle():
	  SUPER().
	END CONSTRUCTOR.

  CONSTRUCTOR PUBLIC DocumentoConDetalle(INPUT ipobSessionManager AS CLASS SessionManager):
	  SUPER(ipobSessionManager).
	END CONSTRUCTOR.

  CONSTRUCTOR PUBLIC DocumentoConDetalle(INPUT ipchFiltro AS CHARACTER, INPUT ipobSessionManager AS CLASS SessionManager):
	  SUPER(ipchFiltro, ipobSessionManager).
	END CONSTRUCTOR.
END CLASS.
