{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING icomun.dao.GenericServiceDAO.
USING icomun.dao.SessionManager.
USING nsra.utiles.excepciones.Exception.

/* <%TRADUCCION%>Implementa la entidad de negocios Representante de ventas (SalesRep), la cual est relacionada a 
     la Orden de venta (Order).</%TRADUCCION%>
   <%TRADUCCION%>Es una entidad principal y hereda de GenericServiceDAO para que se lo pueda utilizar en forma genrica 
    desde los servicios.</%TRADUCCION%>
*/
CLASS  sports.dao.RepresentanteVentas  INHERITS  GenericServiceDAO :
      {sports/tablas/RepresentanteVentas.i &SCOPE=PROTECTED &ENV=c}

  DEFINE PROTECTED DATASET cpdRepresentanteVentas FOR cttRepresentanteVentas.

/* <%TRADUCCION%>Propiedades para acceder a los atributos de la entidad.</%TRADUCCION%> */
  DEFINE PUBLIC PROPERTY cchIdentificador AS CHARACTER NO-UNDO
    GET():
      RETURN chGetFieldValue('Identificador').
    END GET.
    SET(INPUT ipchIdentificador AS CHARACTER):
      setFieldValue('Identificador',ipchIdentificador).
    END SET.

  DEFINE PUBLIC PROPERTY cchNombre AS CHARACTER NO-UNDO
    GET():
      RETURN chGetFieldValue('Nombre').
    END GET.
    SET(INPUT ipchNombre AS CHARACTER):
      SetFieldValue('Nombre', ipchNombre).
    END SET.
 
/* <%TRADUCCION%>Constructores</%TRADUCCION%> */
/* <%TRADUCCION%>Este es el constructor utilizado por la fbrica de la clase.</%TRADUCCION%> */
  CONSTRUCTOR PUBLIC  RepresentanteVentas():
	    SUPER(BUFFER cttRepresentanteVentas:HANDLE).
	END CONSTRUCTOR.

/* <%TRADUCCION%>Estos constructores no suelen utilizarse, pero es necesario sobrescribirlos.</%TRADUCCION%> */
  CONSTRUCTOR PUBLIC  RepresentanteVentas(INPUT ipobSessionManager AS CLASS SessionManager):
	    SUPER(BUFFER cttRepresentanteVentas:HANDLE, ipobSessionManager).
	END CONSTRUCTOR.

  CONSTRUCTOR PUBLIC  RepresentanteVentas(INPUT ipchFiltro AS CHARACTER, INPUT ipobSessionManager AS CLASS SessionManager):
	    SUPER(BUFFER cttRepresentanteVentas:HANDLE, ipobSessionManager).
    FillData(ipchFiltro).
	END CONSTRUCTOR.

/* <%TRADUCCION%>Mtodo de la interfaz genrica de servicio, que permite a los servicios de actualizacin de datos
    la modificacin de los datos de la entidad, utilizando un buffer como parmetro de entrada. </%TRADUCCION%> */
  	METHOD PUBLIC OVERRIDE VOID  AssignValues( iphbBuffer AS HANDLE, ipchFieldMap AS CHARACTER ):
	    /* <%TRADUCCION%>Verificar que los campos requeridos hayan sido especificados.</%TRADUCCION%> */ 
	    verifyFields( "Identificador,Nombre", iphbBuffer, ipchFieldMap, cobSessionManager:cobTraductor:Traducir("El Representante debe tener identificador.,El Representante debe tener nombre.") ).
        SUPER:assignValues(iphbBuffer, ipchFieldMap).
	END METHOD.

END CLASS.