{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING nsra.utiles.fabricas.Factory.
USING sports.dao.Articulo.
/**
 * Fabrica para los objetos Expediente.
 */
CLASS sports.dao.fabricas.ArticuloFactory INHERITS Factory:
  /**
   * El instaciador por omisin.
   */
  METHOD OVERRIDE PUBLIC Progress.Lang.Object DefaultInstance():
    DEFINE VARIABLE mobTempObject AS CLASS Articulo NO-UNDO.
    mobTempObject = NEW Articulo().

    IF AddInstance(mobTempObject) THEN
       RETURN mobTempObject.
    ELSE
       RETURN ?.
  END METHOD.

  METHOD PUBLIC CLASS Articulo NewInstance():
    RETURN CAST(DefaultInstance(),Articulo).
  END METHOD.

  METHOD PUBLIC CLASS Articulo GetInstance():
    RETURN CAST(GetGenericInstance(),Articulo).
  END METHOD.
END CLASS.
