{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING nsra.utiles.fabricas.Factory.
USING sports.dao.Factura.
/**
 * Fabrica para los objetos Expediente.
 */
CLASS sports.dao.fabricas.FacturaFactory INHERITS Factory:
  /**
   * El instaciador por omisin.
   */
  METHOD OVERRIDE PUBLIC Progress.Lang.Object DefaultInstance():
    DEFINE VARIABLE mobTempObject AS CLASS Factura NO-UNDO.
    mobTempObject = NEW Factura().

    IF AddInstance(mobTempObject) THEN
       RETURN mobTempObject.
    ELSE
       RETURN ?.
  END METHOD.

  METHOD PUBLIC CLASS Factura NewInstance():
    RETURN CAST(DefaultInstance(),Factura).
  END METHOD.

  METHOD PUBLIC CLASS Factura GetInstance():
    RETURN CAST(GetGenericInstance(),Factura).
  END METHOD.
END CLASS.
