{nsra/utiles/runlevel.i}
{sports/utiles/dbase.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING nsra.dso.ReferencedDataSource.

/* <%TRADUCCION%>esta clase se encarga de realizar el llenado de la Temp-Table con el mismo nombre, como as tambin 
    de la grabacin de los cambios en la base de datos</%TRADUCCION%>
*/
CLASS  sports.dso.ArticulosProveedor  INHERITS  nsra.dso.ReferencedDataSource :
  DEFINE PROTECTED BUFFER  cbfSupplierItemXref  FOR  {&SPORTS-DB}.SupplierItemXref .

	METHOD PROTECTED OVERRIDE VOID  DefineDataSource() :
	/* <%TRADUCCION%>esta es la forma ms simple de definicin, en donde lo nico que se requiere es un mapeo directo 
	    de los campos de la Temp-Table respecto de los de la tabla correspondiente en la base de datos</%TRADUCCION%> 
	*/
        AddBuffer(BUFFER cbfSupplierItemXref:HANDLE, "SupplierIDNum,ItemNum").
        AddMapField("cbfSupplierItemXref", "SupplierIDNum", "CodigoProveedor", TRUE).
        AddMapField("cbfSupplierItemXref", "Itemnum" ,      "CodigoArticulo",  TRUE).
	END METHOD.
      
    METHOD PROTECTED OVERRIDE VOID SetUpRelations():      
      /* <%TRADUCCION%>Mtodo utilizado para establecer restricciones de integridad.</%TRADUCCION%> */    
      /* <%TRADUCCION%>Aplicar cambios y borrados de Proveedor y Articulo en cascada a los ArticulosProveedor.</%TRADUCCION%> */  
      AddRelation(ACTION_CASCADE,OPERATION_UPDATE + OPERATION_DELETE, 'sports.dso.Articulo' , 'Codigo', 'CodigoArticulo' ) .
      AddRelation(ACTION_CASCADE,OPERATION_UPDATE + OPERATION_DELETE, 'sports.dso.Proveedor', 'Codigo', 'CodigoProveedor') .
    END METHOD.
	
END CLASS.