{nsra/utiles/runlevel.i}
{sports/utiles/dbase.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING nsra.dso.ReferencedDataSource.

/* <%TRADUCCION%>esta clase se encarga de realizar el llenado de la Temp-Table con el mismo nombre, como as tambin de la grabacin
de los cambios en la base de datos</%TRADUCCION%> */
CLASS sports.dso.Familia INHERITS nsra.dso.ReferencedDataSource:
  DEFINE PROTECTED BUFFER cbfFamily FOR {&SPORTS-DB}.Family .
  
	METHOD PROTECTED OVERRIDE VOID DefineDataSource():
	  /* <%TRADUCCION%>esta es la forma ms simple de definicin, en donde lo nico que se requiere es un mapeo directo de los
	  campos de la Temp-Table respecto de los de la tabla correspondiente en la base de datos</%TRADUCCION%> */
     AddBuffer(BUFFER cbfFamily:HANDLE, "EmpNum,RelativeName"). /* <%TRADUCCION%>clave primaria compuesta</%TRADUCCION%> */
     AddMapField("cbfFamily", "EmpNum",  "CodEmpleado", TRUE).
     AddMapField("cbfFamily", "RelativeName", "Nombre", TRUE).
     AddMapField("cbfFamily", "Relation", "Parentesco", TRUE).
     AddMapField("cbfFamily", "Birthdate", "FechaNacimiento"). 
     AddMapField("cbfFamily", "CoveredOnBenefits", "Beneficiado",TRUE).
     AddMapField("cbfFamily", "BenefitDate","FechaBeneficio",TRUE).
    END METHOD.

  METHOD PROTECTED OVERRIDE VOID SetUpRelations():
    /* <%TRADUCCION%>restricciones de integridad referencial</%TRADUCCION%> */
    AddRelation(ACTION_CASCADE,OPERATION_UPDATE + OPERATION_DELETE,'sports.dso.Empleado','Codigo','CodEmpleado').
  END METHOD.
END CLASS.