{nsra/utiles/runlevel.i}
{sports/utiles/dbase.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING nsra.dso.ReferencedDataSource.

CLASS sports.dso.Situacion INHERITS nsra.dso.ReferencedDataSource:
  /* valores fijos, creo la tabla aqu */
  {sports/tablas/Situacion.i &SCOPE=PROTECTED}

  CONSTRUCTOR Situacion():
    SUPER().
    CREATE ttSituacion.
    ASSIGN
      id = 'Received'
      Nombre = 'Recibido'
    {&END}
    CREATE ttSituacion.
    ASSIGN
      id = 'Ordered'
      Nombre = 'Pedido'
    {&END}
    CREATE ttSituacion.
    ASSIGN
      id = 'Shipped'
      Nombre = 'Embarcado'
    {&END}
    CREATE ttSituacion.
    ASSIGN
      id = 'Partially Shipped'
      Nombre = 'Parcialmente Embarcado'
    {&END}
  END CONSTRUCTOR.

  METHOD PUBLIC OVERRIDE LOGICAL AttachTable(INPUT iphtTable AS HANDLE):
    chnDataSetBuffer = iphtTable.
    AddFillEvent(BEFORE-FILL,'FillData').
    RETURN TRUE.
  END METHOD.

  METHOD PUBLIC OVERRIDE LOGICAL DetachTable():
    chnDataSetBuffer = ?.
    RemoveFillEvent(BEFORE-FILL,'FillData').
    RETURN TRUE.
  END METHOD.

  METHOD PUBLIC INTEGER FillData(INPUT DATASET-HANDLE iphdDataSet):
    FOR EACH ttSituacion:
      chnDataSetBuffer:BUFFER-CREATE().
      chnDataSetBuffer:BUFFER-COPY(BUFFER ttSituacion:HANDLE).
    END.
  END METHOD.

  METHOD PUBLIC OVERRIDE LOGICAL SetFilter(INPUT ipchExpresion AS CHARACTER,INPUT iplgLooseMode AS LOGICAL,INPUT iplgLaxed AS LOGICAL):
    RETURN TRUE.
  END METHOD.
END CLASS.
