{nsra/utiles/runlevel.i}
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING icomun.dao.*.
USING nsxml.dao.*.
USING nsxml.utiles.*.
USING sports.dao.*.
USING nsra.dao.BasicDAO.
USING nsra.utiles.ExpManagerSQL.
USING nsra.utiles.excepciones.Exception.

DEFINE INPUT PARAMETER lobSM AS CLASS SessionManager.

{sports/tablas/Departamento.i}
  
/*************************
 * Servicio lookdepartamento
 *************************/
PROCEDURE lookdepartamento:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchSearch AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipinLimit AS INTEGER NO-UNDO.

  DEFINE OUTPUT  PARAMETER ophnSalida AS HANDLE NO-UNDO.

  DEFINE VARIABLE iobCallee AS CLASS Departamento NO-UNDO.
  DEFINE VARIABLE iobGenerico AS CLASS XULService NO-UNDO. 

  iobCallee = CAST(lobSM:cobBroker:NewObject('sports.dao.Departamento'),Departamento).
  iobGenerico = CAST(lobSM:cobBroker:NewObject('nsxml.utiles.XULService'),XULService).
  ophnSalida = iobGenerico:FillLookupTable(iobCallee,ipchSQL,ipchSQL,ipchColumns,ipchReference,ipchSearch,ipinLimit,TEMP-TABLE ttDepartamento:HANDLE,iobCallee,'').

  FINALLY:
    lobSM:cobBroker:FreeObject(iobGenerico).
    lobSM:cobBroker:FreeObject(iobCallee).
  END FINALLY.
END PROCEDURE.


/*****************************
 * Servicio looklabdepartamento
 *****************************/
PROCEDURE looklabdepartamento:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.

  DEFINE OUTPUT  PARAMETER ophnSalida AS HANDLE NO-UNDO.

  DEFINE VARIABLE lobCallee AS CLASS Departamento NO-UNDO.
  DEFINE VARIABLE lobGenerico AS CLASS XULService NO-UNDO.

  lobCallee = CAST(lobSM:cobBroker:NewObject('sports.dao.Departamento'),Departamento).
  lobGenerico = CAST(lobSM:cobBroker:NewObject('nsxml.utiles.XULService'),XULService).
  ophnSalida = lobGenerico:FillLookupLabel(lobCallee,ipchSQL,ipchSQL,ipchColumns,'identificador',TEMP-TABLE ttDepartamento:HANDLE,lobCallee,'').

  FINALLY:
    lobSM:cobBroker:FreeObject(lobGenerico).
    lobSM:cobBroker:FreeObject(lobCallee).
  END FINALLY.
END PROCEDURE.

{sports/tablas/RepresentanteVentas.i}
  
/*************************
 * Servicio lookRepresentanteVentas
 *************************/
PROCEDURE lookRepresentanteVentas:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchSearch AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipinLimit AS INTEGER NO-UNDO.

  DEFINE OUTPUT  PARAMETER ophnSalida AS HANDLE NO-UNDO.

  DEFINE VARIABLE iobCallee AS CLASS RepresentanteVentas NO-UNDO.
  DEFINE VARIABLE iobGenerico AS CLASS XULService NO-UNDO. 

  iobCallee = CAST(lobSM:cobBroker:NewObject('sports.dao.RepresentanteVentas'),RepresentanteVentas).
  iobGenerico = CAST(lobSM:cobBroker:NewObject('nsxml.utiles.XULService'),XULService).
  ophnSalida = iobGenerico:FillLookupTable(iobCallee,ipchSQL,ipchSQL,ipchColumns,ipchReference,ipchSearch,ipinLimit,TEMP-TABLE ttRepresentanteVentas:HANDLE,iobCallee,'').

  FINALLY:
    lobSM:cobBroker:FreeObject(iobGenerico).
    lobSM:cobBroker:FreeObject(iobCallee).
  END FINALLY.
END PROCEDURE.

{sports/tablas/Articulo.i}
  
/*************************
 * Servicio lookArticulo
 *************************/
PROCEDURE lookArticulo:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchSearch AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipinLimit AS INTEGER NO-UNDO.

  DEFINE OUTPUT  PARAMETER ophnSalida AS HANDLE NO-UNDO.

  DEFINE VARIABLE iobCallee AS CLASS Articulo NO-UNDO.
  DEFINE VARIABLE iobGenerico AS CLASS XULService NO-UNDO. 

  iobCallee = CAST(lobSM:cobBroker:NewObject('sports.dao.Articulo'),Articulo).
  iobGenerico = CAST(lobSM:cobBroker:NewObject('nsxml.utiles.XULService'),XULService).
  ophnSalida = iobGenerico:FillLookupTable(iobCallee,ipchSQL,ipchSQL,ipchColumns,ipchReference,ipchSearch,ipinLimit,TEMP-TABLE ttArticulo:HANDLE,iobCallee,'').

  FINALLY:
    lobSM:cobBroker:FreeObject(iobGenerico).
    lobSM:cobBroker:FreeObject(iobCallee).
  END FINALLY.
END PROCEDURE.

{sports/tablas/Proveedor.i}
  
/*************************
 * Servicio lookProveedor
 *************************/
PROCEDURE lookProveedor:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchSearch AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipinLimit AS INTEGER NO-UNDO.

  DEFINE OUTPUT  PARAMETER ophnSalida AS HANDLE NO-UNDO.

  DEFINE VARIABLE iobCallee AS CLASS Proveedor NO-UNDO.
  DEFINE VARIABLE iobGenerico AS CLASS XULService NO-UNDO. 

  iobCallee = CAST(lobSM:cobBroker:NewObject('sports.dao.Proveedor'),Proveedor).
  iobGenerico = CAST(lobSM:cobBroker:NewObject('nsxml.utiles.XULService'),XULService).
  ophnSalida = iobGenerico:FillLookupTable(iobCallee,ipchSQL,ipchSQL,ipchColumns,ipchReference,ipchSearch,ipinLimit,TEMP-TABLE ttProveedor:HANDLE,iobCallee,'').

  FINALLY:
    lobSM:cobBroker:FreeObject(iobGenerico).
    lobSM:cobBroker:FreeObject(iobCallee).
  END FINALLY.
END PROCEDURE.
PROCEDURE looklabproveedor:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.

  DEFINE OUTPUT  PARAMETER ophnSalida AS HANDLE NO-UNDO.

  DEFINE VARIABLE lobCallee AS CLASS Proveedor NO-UNDO.
  DEFINE VARIABLE lobGenerico AS CLASS XULService NO-UNDO.

  lobCallee = CAST(lobSM:cobBroker:NewObject('sports.dao.Proveedor'),Proveedor).
  lobGenerico = CAST(lobSM:cobBroker:NewObject('nsxml.utiles.XULService'),XULService).
  ophnSalida = lobGenerico:FillLookupLabel(lobCallee,ipchSQL,ipchSQL,ipchColumns,'codigo',TEMP-TABLE ttProveedor:HANDLE,lobCallee,'').

  FINALLY:
    lobSM:cobBroker:FreeObject(lobGenerico).
    lobSM:cobBroker:FreeObject(lobCallee).
  END FINALLY.
END PROCEDURE.

{sports/tablas/Documento.i &EXTRA-FIELDS="FIELD Recepcion AS DATETIME FIELD NombreArticulo AS CHARACTER"}
  
/*************************
 * Servicio lookOrdenCompra
 *************************/
PROCEDURE lookOrdenCompra:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchSearch AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipinLimit AS INTEGER NO-UNDO.

  DEFINE OUTPUT  PARAMETER ophnSalida AS HANDLE NO-UNDO.

  DEFINE VARIABLE iobCallee AS CLASS OrdenCompra NO-UNDO.
  DEFINE VARIABLE iobGenerico AS CLASS XULService NO-UNDO. 
  DEFINE VARIABLE iobArticulo AS CLASS Articulo NO-UNDO.

  iobCallee = CAST(lobSM:cobBroker:NewObject('sports.dao.OrdenCompra'),OrdenCompra).
  iobGenerico = CAST(lobSM:cobBroker:NewObject('nsxml.utiles.XULService'),XULService).
  ophnSalida = iobGenerico:FillLookupTable(iobCallee,ipchSQL,ipchSQL,ipchColumns,ipchReference,ipchSearch,ipinLimit,TEMP-TABLE ttDocumento:HANDLE,iobCallee,'ordencompra,documento').

  iobArticulo = CAST(lobSM:cobBroker:NewObject('sports.dao.Articulo'),Articulo).
  FOR EACH ttDocumento BY numero:
    IF iobArticulo:EntityExists('Codigo EQ ' + STRING(iobArticulo:cinNumero)) THEN
      ttDocumento.NombreArticulo = iobArticulo:cchNombre.
  END.

  FINALLY:
    lobSM:cobBroker:FreeObject(iobGenerico).
    lobSM:cobBroker:FreeObject(iobCallee).
    lobSM:cobBroker:FreeObject(iobArticulo).
  END FINALLY.
END PROCEDURE.

{sports/tablas/Empleado.i}
  
/*************************
 * Servicio lookEmpleado
 *************************/
PROCEDURE lookEmpleado:
  DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchSearch AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER ipinLimit AS INTEGER NO-UNDO.

  DEFINE OUTPUT  PARAMETER ophnSalida AS HANDLE NO-UNDO.

  DEFINE VARIABLE iobCallee AS CLASS Empleado NO-UNDO.
  DEFINE VARIABLE iobGenerico AS CLASS XULService NO-UNDO. 

  iobCallee = CAST(lobSM:cobBroker:NewObject('sports.dao.Empleado'),Empleado).
  iobGenerico = CAST(lobSM:cobBroker:NewObject('nsxml.utiles.XULService'),XULService).
  ophnSalida = iobGenerico:FillLookupTable(iobCallee,ipchSQL,ipchSQL,ipchColumns,ipchReference,ipchSearch,ipinLimit,TEMP-TABLE ttEmpleado:HANDLE,iobCallee,'').

  FINALLY:
    lobSM:cobBroker:FreeObject(iobGenerico).
    lobSM:cobBroker:FreeObject(iobCallee).
  END FINALLY.
END PROCEDURE.


{sports/tablas/Almacen.i}
  
/*************************
 * Servicio lookalmacen
 *************************/
PROCEDURE lookalmacen:
    DEFINE INPUT PARAMETER ipchSQL AS CHARACTER NO-UNDO.
    DEFINE INPUT PARAMETER ipchReference AS CHARACTER NO-UNDO.
    DEFINE INPUT PARAMETER ipchSearch AS CHARACTER NO-UNDO.
    DEFINE INPUT PARAMETER ipchColumns AS CHARACTER NO-UNDO.
    DEFINE INPUT PARAMETER ipinLimit AS INTEGER NO-UNDO.

    DEFINE OUTPUT  PARAMETER ophnSalida  AS  HANDLE  NO-UNDO.

    DEFINE VARIABLE iobCallee   AS CLASS  Almacen    NO-UNDO.
    DEFINE VARIABLE iobGenerico AS CLASS  XULService NO-UNDO. 

    iobCallee = CAST( lobSM:cobBroker:NewObject('sports.dao.Almacen'), Almacen ).
    iobGenerico = CAST( lobSM:cobBroker:NewObject('nsxml.utiles.XULService'), XULService ).
    ophnSalida = iobGenerico:FillLookupTable(iobCallee,ipchSQL,ipchSQL,ipchColumns,ipchReference,ipchSearch,ipinLimit,TEMP-TABLE ttAlmacen:HANDLE,iobCallee,'').

    FINALLY:
      lobSM:cobBroker:FreeObject(iobGenerico).
      lobSM:cobBroker:FreeObject(iobCallee).
    END FINALLY.
END PROCEDURE.
