/* <%TRADUCCION%>{&SCOPE} se utiliza para definir la visibilidad de la definicin cuando la inclusin se hace en una clase
   {&ENV} permite agregar el caracter inicial que posibilita incluir varias veces la definicin con diferentes nombres
   {&REF-ONLY} se especifica como TRUE cuando la inclusin la realiza un BaseDAODelegate
   {&EXTRA-FIELDS} permite agregar campos a la definicin al momento de la inclusin. Se lo utiliza en los archivos de servicios</%TRADUCCION%> */
DEFINE {&SCOPE} TEMP-TABLE {&ENV}ttArticulo NO-UNDO  &IF {&REF-ONLY} &THEN REFERENCE-ONLY &ENDIF
  BEFORE-TABLE {&ENV}ttbfArticulo
  FIELD Codigo AS INTEGER INITIAL ?
  FIELD Nombre AS CHARACTER
  FIELD Precio AS DECIMAL
  FIELD EnMano AS INTEGER
  FIELD Ubicado AS INTEGER
  FIELD Pedir AS INTEGER
  FIELD Pedido AS INTEGER
  FIELD PCategoria AS INTEGER
  FIELD DCategoria AS CHARACTER
  FIELD Categoria1 AS CHARACTER
  FIELD Categoria2 AS CHARACTER
  FIELD Especial AS CHARACTER
  FIELD Peso AS DECIMAL
  FIELD CantidadMin AS INTEGER
  {&EXTRA-FIELDS}
  INDEX pkArticulo IS PRIMARY IS UNIQUE Codigo
  INDEX ixNombre Nombre PCategoria DCategoria.
