/* <%TRADUCCION%>{&SCOPE} se utiliza para definir la visibilidad de la definicin cuando la inclusin se hace en una clase
   {&ENV} permite agregar el caracter inicial que posibilita incluir varias veces la definicin con diferentes nombres
   {&REF-ONLY} se especifica como TRUE cuando la inclusin la realiza un BaseDAODelegate
   {&EXTRA-FIELDS} permite agregar campos a la definicin al momento de la inclusin. Se lo utiliza en los archivos de servicios</%TRADUCCION%> */
DEFINE {&SCOPE} TEMP-TABLE {&ENV}ttFuentesPantalla NO-UNDO  &IF {&REF-ONLY} &THEN REFERENCE-ONLY &ENDIF
  BEFORE-TABLE {&ENV}ttbfFuentesPantalla
  FIELD PantallaId AS CHARACTER
  FIELD Numero AS INTEGER
  FIELD Archivo AS CHARACTER
  FIELD Desde AS INTEGER
  FIELD Hasta AS INTEGER
  FIELD ComentarioInicial AS CHARACTER
  FIELD ComentarioFinal AS CHARACTER
  {&EXTRA-FIELDS}
  INDEX pkFuentesPantalla IS PRIMARY IS UNIQUE PantallaId Numero
  INDEX ixArchivo Archivo Desde Hasta.
