/* <%TRADUCCION%>{&SCOPE} se utiliza para definir la visibilidad de la definicin cuando la inclusin se hace en una clase
   {&ENV} permite agregar el caracter inicial que posibilita incluir varias veces la definicin con diferentes nombres
   {&REF-ONLY} se especifica como TRUE cuando la inclusin la realiza un BaseDAODelegate
   {&EXTRA-FIELDS} permite agregar campos a la definicin al momento de la inclusin. Se lo utiliza en los archivos de servicios</%TRADUCCION%> */
DEFINE  {&SCOPE } TEMP-TABLE  {&ENV}ttMovimientoInventario  NO-UNDO  &IF {&REF-ONLY} &THEN REFERENCE-ONLY &ENDIF
      BEFORE-TABLE {&ENV}ttbfMovimientoInventario
      
      FIELD CodigoMovimiento AS INTEGER INITIAL ?
      FIELD CodigoAlmacen AS INTEGER
      FIELD CodigoEstante AS INTEGER
      FIELD Cantidad AS INTEGER
      FIELD CodigoArticulo  AS INTEGER
      FIELD FechaMovimiento AS DATE 
      FIELD HorarioMovimiento AS CHARACTER
      FIELD Tipo AS CHARACTER
      FIELD CodigoOrdenCompra AS INTEGER
      FIELD CodigoOrdenVenta  AS INTEGER
      {&EXTRA-FIELDS}

  INDEX  pkMovimientoInventario  IS PRIMARY IS UNIQUE  CodigoMovimiento .