function connectUserComm(ucid,toolids)
	{
	var uc = document.getElementById(ucid || 'usercomm');
	connect(uc,'show',window,showMess);
	connect(uc,'showClient',window,showMess);
	connect(uc,'hide',window,hideMess);
	connect(uc,'hideClient',window,hideMess);
	connect(uc,'cleared',window,hideMess);
	if(toolids)
		{
		for(var i=0;i<toolids.length;i++)
			connect(document.getElementById(toolids[i]),'cancelOp',uc,'hideDetails');
		};
	};
function showMess(senderid)
	{
	var ucm = document.getElementById(senderid);
	var tabs = document.getElementById(ucm.getAttribute('tabsid') || 'commTabs');
	ucm.prevtab = tabs.selectedIndex;
	tabs.selectedIndex = ucm.getAttribute('tabindex');	
	showPropperTab(ucm.getAttribute('tabindex'));
	};
function hideMess(senderid)
	{
	var ucm = document.getElementById(senderid);
	var ucmti = ucm.getAttribute('tabindex');
	if(!isNaN(ucm.recenterrors) || !isNaN(ucm.recentglobalerrors) || !isNaN(ucm.recentnotifications))
		showPropperTab(ucmti);
	else if(ucm.prevtab!=ucmti)
		showPropperTab(ucm.prevtab,ucmti);
	else
		showPropperTab(0,ucmti);
	};

function checkMail(edit)
	{
	if(/^([a-zA-Z0-9\-\_]+([a-zA-Z0-9\-\_\.]*))\@(([a-zA-Z0-9\-\.]+\.(([a-zA-Z]{3,4}(\.[a-zA-Z]{2})?)|([a-zA-Z]{2,3})))|(\[([0-9]{1,3})(\.[0-9]{1,3}){3}\]))$/.test(edit.value))
		return true;
	if(!edit.value && !edit.hasAttribute('emptyInvalid'))
		return true;
	alert(edit.getAttribute('invalidMess'));
	edit.focus();
	return false;
	};
function showPropperTab(tabindex,iftab)
	{
	var ucm = document.getElementById('usercomm');
	if(ucm)
		var maxtab = ucm.getAttribute('tabindex');
	else
		var maxtab = 3;
	var tabs = document.getElementById('commTabs');
	if(tabs && (tabs.selectedIndex == iftab || (!iftab && iftab !== 0)))
		{
		var deck = document.getElementById('outerdeck');
		if(deck)
			{
			if(tabindex==maxtab)
				deck.selectedIndex = 1;
			else
				{
				deck.selectedIndex = 0;
				deck = document.getElementById('innerdeck');
				deck.selectedIndex = tabindex;
				};
			}
		else
			{
			deck = document.getElementById('paneldeck');
			if(deck)
				{
				if(tabindex==maxtab)
					deck.selectedIndex = 1;
				else
					deck.selectedIndex = 0;
				};
			};
		tabs.selectedIndex = tabindex;
		};
	};
function forcedigits(num)
	{
	num = String(num);
	while(num.length < 2)
		num = '0'+num;
	return num;
	};
function getNow()
	{
	var date = new Date();
	var ahora = forcedigits(date.getDate())+'/'+forcedigits(date.getMonth()+1)+'/'+date.getFullYear()+' ';
	ahora += forcedigits(date.getHours())+':'+forcedigits(date.getMinutes());
	return ahora;
	};
function getAllSelectedRows(grilla,field)
	{
	var selectedRows = grilla.currentSelected(field);
	var result = new Array();
	var fila = grilla.view.rowdata;
	var j=0;
	for(var i=0; i<selectedRows.length; i++)
		{
		var encontro = false;
		while(!encontro && j<fila.length)
			{
			if(selectedRows[i] == grilla.getRowIdFromRefData(grilla.view.refdata[j]))
				{
				encontro=true;
				var filanueva = new Array();
				for(var k=0;k<fila[j].length;k++)
					filanueva.push(fila[j][k]);
				filanueva.push(selectedRows[i]);
				result.push(filanueva);
				}
			j++;
			}
		}
	return result;
	};
function delFromPending(senderId,gridId,field)
	{
	disableAll(senderId);
	try
		{
		var grilla = document.getElementById(gridId);
		var selectedRows = grilla.currentSelected(field);

		for(var i=0; i<selectedRows.length;i++)
			grilla.rowDelete(senderId, selectedRows[i]);
		if(!grilla.localAdds.length)
			grilla.refreshData();
		grilla.selectionChange(true);
		}
	finally
		{
		enableAll(senderId);
		};
	};
function addToPending(senderId,sourceId,sourceField,destId,presetFunc)
	{
	disableAll(senderId);
	try
		{
		var sourcegrid = document.getElementById(sourceId);
		var filas = getAllSelectedRows(sourcegrid,sourceField);
		if(filas.length<=0)
			return;
		var destgrid = document.getElementById(destId);
		var destref = destgrid.localAdds;
		var refpossrc = filas[0].length - 1;
		var refposdst = refpossrc;
		if(destref.length)
			var refposdst = destref[0].length - 1;
		for(var i=filas.length-1; i>=0; i--)
			{
			var uid = filas[i][refpossrc];
			var j=0;
			for(;j<destref.length;j++)
				{
				if(destref[j][refposdst] == uid)
					break;
				};
			if(j<destref.length)
				continue;
			if(presetFunc)
				{
				filas[i] = presetFunc.apply(this,[filas[i],uid]);
				while(filas[i].length < refposdst)
					filas[i].push(uid);
				}
			else
				filas[i][filas[i].length - 1] = uid;
			destgrid.rowAdd(senderId, filas[i]);
			}
		if(destref.length == 1)
			destgrid.refreshData();
		destgrid.selectionChange(true);
		destgrid.view.selection.select(destgrid.view.treebox.getFirstVisibleRow());
		}
	finally
		{
		enableAll(senderId);
		};
	};
	