function SessionAlerter(service,unit)
	{
	this.unit = unit || 1;
	this.timeleft = 1800;
	this.maxtimeleftCB = 1;
	this.service = service || 'alive';
	this.callbacks = new Array();
	if(!window.alertexpirations)
		window.alertexpirations = new Array();
	this.myIndex = window.alertexpirations.push(this)-1;
	return this;
	};
SessionAlerter.prototype.evalCallback = function(indice)
	{
	var func = this.callbacks[indice][2];
	if(typeof(func) == 'function')
		func.apply(window,[this.timeout]);
	else
		eval(func);
	};
SessionAlerter.prototype.addCallback = function(callbackObj,callbackFunc,timeleft)
	{
	var newCB = new Array();
	newCB.push(timeleft);
	if(timeleft > this.maxtimeleftCB)
		this.maxtimeleftCB = timeleft;
	if(typeof(callbackObj) == 'object')
		{
		newCB.push(callbackObj);
		if(typeof(callbackFunc) != 'function')
			callbackFunc = callbackObj[callbackFunc];
		newCB.push(callbackFunc);
		}
	else
		{
		newCB.push(null);
		newCB.push(callbackFunc);
		};
	this.callbacks.push(newCB);
	this.checkCallbacks();
	};
SessionAlerter.prototype.start = function()
	{
	this.reset();
	this.cth = 1;
	this.verifyAlive();
	};
SessionAlerter.prototype.calcularNextTimeOut = function(minThan)
	{
	var nexttimeleft = 0;
	if(minThan)
		{
		for(var i=0;i<this.callbacks.length;i++)
			{
			if(this.callbacks[i][0]<minThan && this.callbacks[i][0]>nexttimeleft)
				nexttimeleft = this.callbacks[i][0];
			};
		};
	if(!nexttimeleft)
		nexttimeleft = this.maxtimeleftCB;
	return nexttimeleft;
	};
SessionAlerter.prototype.processCallbacks = function()
	{
	for(var i=0;i<this.callbacks.length;i++)
		{
		if(this.callbacks[i][0]>this.nexttimeleftCB)
			continue;
		if(this.callbacks[i][0] >= this.timeleft)
			{
			if(this.callbacks[i][1])
				this.callbacks[i][2].apply(this.callbacks[i][1],[this.timeleft]);
			else
				this.evalCallback(i);
			};
		};
	this.nexttimeleftCB = this.calcularNextTimeOut(this.timeleft);
	};
SessionAlerter.prototype.verifyAlive = function(reset)
	{
	if(!this.commProt)
		{
		this.commProt = new NSCommProtocol(this,'processTimeleft');
		this.commProt.setProxyService(_DEFAULT_PROXY_);
		}
	else
		this.commProt.reset('processTimeleft');
	this.commProt.setService(this.service);
	if(reset)
		this.commProt.setSession(window.document.sessionId);
	this.commProt.setParameter('sesion','char,string',window.document.sessionId);
	this.commProt.send();
	};
SessionAlerter.prototype.processTimeleft = function(commp)
	{
	this.timeleft = Number(commp.getAnswer(null,'number,int',0)) * Number(this.unit);
	this.checkCallbacks(this.timeleft);
	};
SessionAlerter.prototype.checkCallbacks = function(timeleft)
	{
	if(timeleft && timeleft<=this.nexttimeleftCB)
		this.processCallbacks();
	else
		this.nexttimeleftCB = this.calcularNextTimeOut();
	if(this.cth)
		{
		clearTimeout(this.cth);
		this.cth = setTimeout('window.alertexpirations['+this.myIndex+'].verifyAlive()',(this.timeleft-this.nexttimeleftCB)*1000);
		};
	};
SessionAlerter.prototype.reset = function()
	{
	if(this.commProt)
		this.commProt.reset('processTimeleft');
	if(this.cth)
		{
		clearTimeout(this.cth);
		delete this.cth;
		};
	this.timeleft = 0;
	};
	