function gridFocuser()
	{
	this.focusedgrid = null;
	this.grids = new Object();
	this.historial = new Array('','');
	var gridtypes = new Array();
	gridtypes.push("abmtablegrid");
	gridtypes.push("tablegrid");
	gridtypes.push("parentchildgrid");
	gridtypes.push("filteredtablegrid");
	gridtypes.push("jerabmtablegrid");
	gridtypes.push("jertablegrid");
	gridtypes.push("jerparentchildgrid");
	gridtypes.push("jerfilteredtablegrid");
	gridtypes.push("cabecera");
	gridtypes.push("abmcabecera");
	for(var i=0;i<gridtypes.length;i++)
		{
		var grids = document.getElementsByTagName(gridtypes[i]);
		for(var j=0;j<grids.length;j++)
			this.grids[grids[j].id] = true;
		};
	return this;
	};
gridFocuser.prototype.getManagerGrid = function(node)
	{
	var childs = node.childNodes;
	var child = null;
	for(var i=0;i<childs.length;i++)
		{
		child = childs.item(i);
		if(this.grids[child.id])
			break;
		child = null;
		};
	if(child && child.showToolbar)
		child.showToolbar();
	return child;
	};
gridFocuser.prototype.signalFocus = function(node)
	{
	while(node && !this.grids[node.id] && node.nodeName != 'abmmanager')
		node = node.parentNode;
	if(!node)
		return;
	if(node.nodeName == 'abmmanager')
		node = this.getManagerGrid(node);
	if(!node)
		return;
	if(this.ifs)
		{
		this.ifscount++;
		if(this.ifscount > 10)
			{
			clearInterval(this.ifs)
			delete this.ifs;
			delete this.lastfocused;
			};
		};
	if(node == this.focusedgrid)
		return;
	if(this.lastfocused && node.id != this.lastfocused)
		return;
	if(this.lastfocused)
		{
		delete this.lastfocused;
		if(this.ifs)
			clearInterval(this.ifs);
		delete this.ifs;
		};
	this.historial[0] = this.historial[1];
	this.historial[1] = node.id;
	if(this.focusedgrid)
		{
		if(this.focusedgrid.hasPendingChanges && this.focusedgrid.hasPendingChanges())
			{
			var manager = this.focusedgrid.parentNode;
			while(manager && manager.nodeName != 'abmmanager')
				manager = manager.parentNode;
			if(!manager || manager.currentOp)
				return;
			};
		var classes = this.focusedgrid.getAttribute('class');
		if(classes)
			{
			var selind = classes.indexOf('selected');
			if(selind>=0)
				classes = classes.substr(0,selind)+classes.substr(selind+9);
			this.focusedgrid.setAttribute('class',classes);
			}
		else
			this.focusedgrid.removeAttribute('class');
		var columns = this.focusedgrid.getMyColumns();
		for(var i=0;i<columns.length;i++)
			columns[i].removeAttribute('selected');
		};
	this.focusedgrid = node;
	var classes = node.getAttribute('class');
	if(classes)
		classes += ' selected';
	else
		classes = 'selected';
	node.setAttribute('class',classes);
	var columns = this.focusedgrid.getMyColumns();
	for(var i=0;i<columns.length;i++)
		columns[i].setAttribute('selected',true);
	};

gridFocuser.prototype.processStart = function(senderid)
	{
	if(!this.inprocess)
		{
		this.inprocess = new Array();
		if(this.historial[1] != senderid && this.historial[0] == senderid)
			this.lastfocused = senderid;
		else
			this.lastfocused = this.focusedgrid.id;
		};
	this.inprocess.push(senderid);
	};

gridFocuser.prototype.processEnd = function(senderid)
	{
	if(!this.inprocess)
		return;
	for(var i=this.inprocess.length-1;i>=0;i--)
		{
		if(this.inprocess[i] == senderid)
			this.inprocess.splice(i,1);
		};
	if(!this.inprocess.length)
		{
		delete this.inprocess;
		if(this.focusedgrid.id != this.lastfocused)
			{
			this.ifscount = 0;
			if(this.lastfocused)
				this.ifs = setInterval('document.getElementById("'+this.lastfocused+'").focus();',100);
			}
		else
			delete this.lastfocused;
		};
	};

function signalgridFocus(event)
	{
	window.gridFocus.signalFocus(event.target);
	};
if(!window.disenAll)
	window.disenAll = new Array();
window.errorData = new Array();
window.errorHandler = function(data)
	{
	var mind = data.indexOf('<message>');
	if(mind>=0)
		{
		var mess = data.substring(mind+9,data.indexOf('</message>'));
		data = data.substring(0,mind-1)+data.substring(data.indexOf('</message>')+10);
		if(mess.indexOf('<![CDATA[')==0)
			mess = mess.substring(9,mess.length-3);
		if(mess)
			{
			if(window.showError)
				window.showError(mess);
			else
				alert(mess);
			};
		}
	else
		{
		tind = data.indexOf('<message/>');
		if(tind>=0)
			data = data.substring(0,tind-1)+data.substring(tind+10);
		};
	window.errorData.push(data);
	};
window.showNotificationError = function(mess,notific)
	{
	var deck=document.getElementById("commdeck");
	if(deck)
		var elem = deck.childNodes.item(3);
	if(deck && elem)
		{
		elem = elem.firstChild;
		var child =document.createElement('vbox');
		child.setAttribute('style','overflow:auto');
		var sepa = document.createElement('label');
		if(notific)
			{
			sepa.setAttribute('value','<%TRADUCCION%>Mensaje:</%TRADUCCION%>');
			sepa.setAttribute('style','font-size:12pt;color:#0000FF');
			}
		else
			{
			sepa.setAttribute('value','<%TRADUCCION%>Error:</%TRADUCCION%>');
			sepa.setAttribute('style','font-size:12pt;color:#FF0000');
			};
		child.appendChild(sepa);
		var desc = document.createElement('description');
		desc.appendChild(document.createTextNode(mess));
		child.appendChild(desc)
		elem.appendChild(child);
		deck.selectedIndex=3;
		document.getElementById("delconf").removeAttribute("collapsed");
		}
	else
		alert(mess);
	};

window.showNotification = function(mess)
	{
	showNotificationError(mess,true);
	};
window.showError = function(mess)
	{
	showNotificationError(mess,false);
	};
window.notificationHandler = function(data)
	{
	if(data.indexOf('<![CDATA[')==0)
		data = data.substring(9,data.length-3);
	if(window.showNotification)
		window.showNotification(data);
	else
		alert(data);
	};
function showWidgets(gridId)
	{
	gridId = gridId || "ABMgrid";
	var grid = document.getElementById(gridId);
	var node = grid.parentNode;
	disconnect(grid,'retrieveEnd',window,showWidgets);
	while(node && (!node.hasAttribute || !node.hasAttribute('collapsed')) && node.nodeName != 'nsinternalwindow')
		node = node.parentNode;
	if(node && node.nodeName != 'nsinternalwindow')
		node.removeAttribute("collapsed");
	while(node && node.nodeName != 'nsinternalwindow')
		node = node.parentNode;
	if(node)
		node.showWindow();
	grid.focus();
	};
function disableAll(requester)
	{
	if(window.alldisabled)
		return;
	window.lastfocused = document.commandDispatcher.focusedElement;
	for(var i=0; i<window.disenAll.length;i++)
		{
		if(window.disenAll[i] != requester)
			{
			var elem = document.getElementById(window.disenAll[i]);
			if(!elem)
				continue;
			if(elem.disableAll)
				elem.disableAll();
			else
				elem.setAttribute("disabled","true");
			};
		};
	window.alldisabled = true;
	};
function enableAll(res)
	{
	if(!window.alldisabled)
		return;
	for(var i=0; i<window.disenAll.length;i++)
		{
		var elem = document.getElementById(window.disenAll[i]);
		if(!elem)
			continue;
		if(elem.enableAll)
			elem.enableAll();
		else
			elem.removeAttribute("disabled");
		};
	if(window.lastfocused)
		window.lastfocused.focus();
	delete window.alldisabled;
	};
function printThis(service,gridId)
	{
	new NSPrintJob(document.getElementById(gridId || "tablegrid"),service).print();
	};
function basicBindConn(gridId, sgId, tbId, manId, commdeckId )
	{
	var grid = document.getElementById(gridId || "ABMgrid");
	var srchgrp = document.getElementById(sgId || "searchGrp");
	var tbar = document.getElementById(tbId || "grid_toolbar");
	var aman = document.getElementById(manId || "tablegrid");
	var cd = document.getElementById(commdeckId || "usercomm");
	if(cd && !cd.errors)
		cd = null;

	if(tbar)
		{
		if(aman)
			{
			aman.toolbar=tbar;
			tbar.ABMmanager=aman;
			}
		else if(grid)
			tbar.tablegrid = grid;
		if(cd)
			{
			if(cd.hasAttribute('dontShowPanes'))
				tbar.commdeck = cd;
			connect(tbar,"accion",cd,"showDelConfirm");
			connect(tbar,"cancelOp",cd,"hideDelConfirm");
			connect(tbar,"doOp",cd,"hideDelConfirm");
			};
		};
	if(grid)
		{
		if(srchgrp)
			{
			srchgrp.tablegrid=grid;
			if(tbar)
				{
				tbar.searchAreaId=srchgrp.id;
				var limiter = srchgrp.getElementsByTagName('searchlimiter').item(0);
				if(limiter && tbar.sortmenu)
					connect(tbar.sortmenu,'groupSelected',limiter,'sortByGroup');
				};
			};
		if(cd)
			{
			connect(grid,"postStart",cd,"postStart");
			connect(grid,"postResult",cd,"postResult");
			if(!cd.relatedIds.length)
				{
				for(var i=0; i<window.disenAll.length;i++)
					cd.relatedIds.push(window.disenAll[i]);
				};
			if(cd.hasAttribute('dontShowPanes'))
				{
				var eds = grid.getElementsByTagName('tablegrideditarea').item(0);
				if(eds)
					{
					eds.commdeck = cd;
					delete eds.columnShowers;
					};
				};
			};
		showWidgets(gridId);
		};
	};
function multiGridBindConn(gridId, parentId, sgId, tbId, manId, tbardeckId,commdeckId,AccStExtra,AccEndExtra,srchgrpdeckId )
	{
	var grid = document.getElementById(gridId || "ABMgrid");
	var srchgrp = document.getElementById(sgId || "searchGrp");
	var tbar = document.getElementById(tbId || "grid_toolbar");
	var aman = document.getElementById(manId || "tablegrid");
	var cd = document.getElementById(commdeckId || "usercomm");
	var tbardeck = document.getElementById(tbardeckId || "toolbarsDeck");
	if(!srchgrpdeckId && document.getElementById('searchDeck'))
		srchgrpdeckId = 'searchDeck';
	if(cd && !cd.errors)
		cd = null;

	if(tbar && cd)
		{
		if(cd.hasAttribute('dontShowPanes'))
			tbar.commdeck = cd;
		connect(tbar,"accion",cd,"showDelConfirm");
		connect(tbar,"cancelOp",cd,"hideDelConfirm");
		connect(tbar,"doOp",cd,"hideDelConfirm");
		};
	if(grid)
		{
		if(!window.gridFocus)
			window.gridFocus = new gridFocuser();
		grid.addEventListener("focus",signalgridFocus,true);
		if(grid.isSignal('postStart'))
			{
			connect(grid,'postStart',window.gridFocus,'processStart',1);
			connect(grid,'postResult',window.gridFocus,'processEnd');
			grid.focusOpStart = function(senderid,proc)
				{
				if(' doAdd doDel doUpd doIns doMve'.indexOf(proc) > 0)
					window.gridFocus.processStart(this);
				};
			grid.focusOpEnd = function(senderid)
				{
				window.gridFocus.processEnd(this);
				};
			};
		if(tbardeck)
			{
			tbardeck.showToolbar = {
				binding:tbardeck,
				handleEvent:function(event)
					{
					showToolbar(event,this.binding.id,srchgrpdeckId);
					}
				};
			grid.tbardeckId = tbardeck.id;
			grid.showToolbar = function(){
				showToolbar({target:this},this.tbardeckId,srchgrpdeckId);
				};
			grid.addEventListener("focus",tbardeck.showToolbar,true);
			};
		if(tbar)
			{
			if(aman)
				{
				aman.commdeckId = commdeckId || 'usercomm';
				aman.parentId = parentId;
				aman.AccStExtra = AccStExtra;
				aman.actionStart = function(senderId,proc)
					{
					var managerId = this.id;
					actionStart(this.id,proc,this.commdeckId,this.parentId);
					if(this.AccStExtra)
						eval(this.AccStExtra);
					};
				connect(tbar,'accion',aman,aman.actionStart,1);
				aman.AccEndExtra = AccEndExtra;
				aman.actionEnd = function()
					{
					var managerId = this.id;
					enableAll();
					if(this.AccEndExtra)
						eval(this.AccEndExtra);
					};
				connect(tbar,'cancelOp',aman,aman.actionEnd);
				connect(tbar,'doOp',aman,aman.actionEnd);
				aman.toolbar=tbar;
				tbar.ABMmanager=aman;
				/* manejo del foco */
				connect(tbar,'accion',grid,'focusOpStart');
				connect(tbar,'cancelOp',grid,'focusOpEnd');
				connect(tbar,'doOp',grid,'focusOpEnd');
				}
			else
				tbar.tablegrid = grid;
			};
		if(parentId)
			{
			grid.setAttribute('commonParentGrid',parentId);
			grid.parentGrid = document.getElementById(parentId);
			if(grid.parentGrid.childsResetted)
				resetChilds(parentId);
			function findParentRel(node,array,field)
				{
				var dotpos = field.indexOf('.');
				if(dotpos > 0)
					field = field.substr(dotpos + 1);
				var childs = node.childNodes;
				for(var i=0; i<childs.length;i++)
					{
					if(childs.item(i).hasAttribute('showColumn'))
						{
						if(childs.item(i).getAttribute('showColumn')==field)
							{
							array.push(childs.item(i));
							return true;
							};
						};
					if(childs.item(i).hasAttribute('showColumns'))
						{
						if(findParentRel(childs.item(i),array,field))
							return true;
						};
					};
				return false;
				};
			var fields = grid.childref.split('/');
			if(!fields[fields.length-1])
				fields.pop();
			grid.parentRels = new Array();
			for(var f=0;f<fields.length;f++)
				{
				if(!findParentRel(grid,grid.parentRels,fields[f]))
					grid.parentRels.push(null);
				};
			}
		else
			{
			if(!window.commonMainGrid)
				window.commonMainGrid = grid.id;
			if(grid.hasAttribute('delayChildren'))
				{
				connect(grid,'retrieveEnd',window,resetChilds);
				if(!grid.hasAttribute('dontClearRetention'))
					{
					if(grid.commRetained)
						{
						grid.view.reset();
						grid.view.retrieveData();
						};
					grid.commRetained = false;
					};
				};
			};
		if(srchgrp && (sgId || !parentId))
			{
			srchgrp.tablegrid=grid;
			if(tbar)
				{
				tbar.searchAreaId=srchgrp.id;
				var limiter = srchgrp.getElementsByTagName('searchlimiter').item(0);
				if(limiter && tbar.sortmenu)
					connect(tbar.sortmenu,'groupSelected',limiter,'sortByGroup');
				};
			};
		if(cd)
			{
			connect(grid,"postStart",cd,"postStart");
			connect(grid,"postResult",cd,"postResult");
			if(!cd.relatedIds.length)
				{
				for(var i=0; i<window.disenAll.length;i++)
					cd.relatedIds.push(window.disenAll[i]);
				};
			if(cd.hasAttribute('dontShowPanes'))
				{
				var eds = grid.getElementsByTagName('tablegrideditarea').item(0);
				if(eds)
					{
					eds.commdeck = cd;
					delete eds.columnShowers;
					};
				};
			};
		};
	if(window.initedCount !== undefined)
		window.initedCount -= 1;
	if(!window.initedCount)
		{
		var grid = document.getElementById(window.commonMainGrid);
		if(grid)
			{
			var node = grid.parentNode;
			while(node && (!node.hasAttribute || !node.hasAttribute('collapsed'))&& node.nodeName != 'nsinternalwindow')
				node = node.parentNode;
			if(node && node.nodeName != 'nsinternalwindow')
				node.removeAttribute("collapsed");
			while(node && node.nodeName != 'nsinternalwindow')
				node = node.parentNode;
			if(node)
				node.showWindow();
			grid.focus();
			};
		};
	};
function resetChilds(gridId)
	{
	var grid = document.getElementById(gridId);
	var childs = document.getElementsByAttribute('commonParentGrid',gridId);
	disconnect(grid,'retrieveEnd',window,resetChilds);
	grid.childsResetted = true;
	if(grid.hasAttribute('restrictToParent'))
		grid.requireParent = true;
	var gcode = grid.currentValue(grid.getAttribute('reffield'));
	for(var i=0; i<childs.length;i++)
		{
		var child = childs.item(i);
		connect(child,'retrieveEnd',window,resetChilds);
		child.view.reset();
		delete child.currentfilter;
		child.parentChange('',gcode);
		child.commRetained = false;
		if(!gcode)
			resetChilds(child.id);
		};
	};
function actionStart(senderId,proc,commdId,parentId)
	{
	document.getElementById(commdId || 'usercomm').showDelConfirm('',proc);
	if(proc=="doAdd" || proc=="doUpd" || proc=="doDel" || proc=="doPost")
		{
		disableAll(senderId);
		if(proc == "doAdd")
			window.doingAdd = true;
		}
	else if(proc == "doAcpt" && window.doingAdd && parentId)
		{
		var parentGrid = document.getElementById(parentId);
		var grid = document.getElementById(senderId);
		if(grid.nodeName == 'abmmanager')
			grid = grid.ABMgrid;
		var rels = grid.parentRels;
		var fields = grid.parentref.split('/');
		if(!fields[fields.length-1])
			fields.pop();
		for(var i=0; i<fields.length;i++)
			{
			if(rels[i])
				rels[i].value = parentGrid.currentValue(fields[i]);
			};
		delete window.doingAdd;
		}
	else if(window.doingAdd && proc == "doCncl")
		delete window.doingAdd;
	};
function showToolbar(event,deckId,srchdeck)
	{
	var node=event.target;
	while(node && node.hasAttribute && !node.hasAttribute("deckindex"))
		node = node.parentNode;
	if(node && node.hasAttribute)
		{
		var deckindex = node.getAttribute("deckindex");
		var deck = document.getElementById(deckId || 'toolbarsDeck');

		if(srchdeck)
			{
			var srchindex = deckindex;
			if(node.hasAttribute("decksearch"))
				srchindex = node.getAttribute("decksearch");
			document.getElementById(srchdeck).selectedIndex = srchindex;
			};

		while(node && node.nodeName != 'nsinternalwindow')
			node = node.parentNode;
		if(node)
			{
			if(node.currentToolbarId)
				{
				var current = document.getElementById(node.currentToolbarId);
				if(current)
					current = current.ABMmanager;
				if(current && current.currentOp)
					return;
				};
			node.currentToolbarId = deck.childNodes.item(deckindex).id;
			};
		deck.selectedIndex = deckindex;
		};
	};
function changeReferenceLabel(senderId,op)
	{
	if(op == "doIns" || op == "doMve")
		document.getElementById('referenceLabel').value = '<%TRADUCCION%>Referencia:</%TRADUCCION%>';
	else if(op == "doAcpt" || op == "doCncl")
		document.getElementById('referenceLabel').value = '<%TRADUCCION%>Padre:</%TRADUCCION%>';
	};
function logicResult(commp,index)
	{
	var atts = {};
	var answ = commp.getAnswer(null,"logic",index,atts);
	atts = String(atts.subtype).split(',');
	return (String(atts.subtype).length && String(answ).indexOf(atts[0])==0);
	};
	